DECLARE SUB sndbyt ()

DECLARE SUB sndbyt ()
DECLARE SUB initlz ()
DECLARE SUB title ()
DECLARE FUNCTION txpll2frq! (frqh!, frql!)
DECLARE FUNCTION ctrxpmr! (chan!)
DECLARE FUNCTION cttxpmr! (chan!)
DECLARE FUNCTION setlrx! (frqh!, frql!, chan!)
DECLARE FUNCTION setltx! (frqh!, frql!, chan!)
DECLARE FUNCTION setlctrx! (chan!, num!)
DECLARE FUNCTION setlcttx! (chan!, num!)
DECLARE FUNCTION txpmr! (chan!)
DECLARE FUNCTION ctcrx! (chan!)
DECLARE FUNCTION ctctx! (chan!)
DECLARE FUNCTION rxpmr! (chan!)
DECLARE FUNCTION pmrfx! (x!)
DECLARE FUNCTION pmrfy! (x!)
DECLARE FUNCTION pll2frq (frqh, frql)
'  AML radio eeprom program
'  02.25.92 bcl
' This backup has EEPROM store/recall in working order
'
'  Radio Unlock process
'     AML needs a waveform with each 1/2 cycle < 2500uS to unlock
'
'  Connect radio to IBM via special cable
'  Printer port DB-25 connector
'  Pin 2 = data output    888,1
'  Pin 3 = clock output   888,2
'  Pin 10 = clock input   889,64
'  Pin 11 = data input    889,128
'  Pin 4 = pullup         888,4
'  Pin 19 = GND
'    to read pins 10(3),11(2) put 1's on 2,3
'
COMMON SHARED ctr
CLEAR , , 4000

ver$ = "06.22.92 AML EEPROM programming program"

DIM SHARED eeps(16), page(2), image(128, 16), ctcss(78)
DIM SHARED zfmin, zfmax, zfsp, fint, arp, pmr, mar, x, y, a, dsp, O
DIM SHARED byt1, byt2, mid, low, hi


mid = 10
low = 7
hi = 13

OUT 888, 5

zfmin = 144
zfmax = 174
zfsp = .00625
fint = 9
arp = 0
pmr = 0
mar = 0

CLS

CALL initlz

main:
  dun = 4
  COLOR 15, 1, 1
  CLS

  FOR x = 1 TO 5
    KEY(x) ON
  NEXT x
  KEY(10) ON

  title

  GOSUB mainmnu

  dsp = 0
main1:

  ON KEY(1) GOSUB startnew
  ON KEY(2) GOSUB recalldsk
  ON KEY(3) GOSUB save2dsk
  ON KEY(4) GOSUB recalleep
  ON KEY(5) GOSUB program
  ON KEY(10) GOSUB theend
  IF dsp = 1 THEN GOTO main
GOTO main1

save2dsk:

 dsp = 1
 COLOR 15, 1, 1
 CLS
 title
 LOCATE 8, 20
 INPUT "Enter filename to store to "; f$
 OPEN f$ FOR OUTPUT AS #1
 PRINT #1, ver$
 FOR x = 0 TO 127
   FOR y = 0 TO 15
     PRINT #1, image(x, y)
     LOCATE 10, 33
     PRINT USING "Saving ### "; x
   NEXT y
 NEXT x
 CLOSE #1

RETURN

startnew:

  dsp = 0
  COLOR 15, 1, 1
  CLS
  title

  GOSUB menu1

  FOR x = 1 TO 6
    KEY(x) ON
  NEXT x
  FOR x = 7 TO 25
    KEY(x) OFF
  NEXT x
  KEY(10) ON

  ON KEY(1) GOSUB prgarp
  ON KEY(2) GOSUB prglnd
  ON KEY(3) GOSUB pmrenc
  ON KEY(4) GOSUB pmrdec
  ON KEY(5) GOSUB lndfrq
  ON KEY(6) GOSUB prgmar
  ON KEY(10) GOSUB gomain

strt1:

  IF dsp = 1 THEN GOTO startnew
  IF dsp = 2 THEN
    dsp = 1
    RETURN
  END IF
GOTO strt1

gomain:
  dsp = 2
RETURN


recalldsk:
  dsp = 1
  COLOR 15, 1, 1
  CLS
  title

  LOCATE 8, 20
  INPUT "Enter filename to recall from "; f$
  OPEN f$ FOR INPUT AS #1
  INPUT #1, a$
  IF a$ <> ver$ THEN
    LOCATE 10, 20
    PRINT "ERROR!! Wrong version/invalid data file"
    LOCATE 11, 24
    PRINT "Press any key to return to menu"
    GOSUB anykey
    CLOSE #1
    RETURN
  END IF
  FOR x = 0 TO 127
    FOR y = 0 TO 15
      INPUT #1, image(x, y)
      LOCATE 10, 32
      PRINT USING "Reading ### "; x
    NEXT y
  NEXT x
  CLOSE #1

  GOSUB chkmode

RETURN


lndfrq:
  dsp = 1
  CLS
  title

  LOCATE 3, 20
  COLOR 15, 8, 8
  PRINT "    Programmed Land Mobile channels     "
  COLOR dun, 7, 7

  FOR x = 0 TO 99
    pmrdat = image(pmrfx!(x), pmrfy!(x))
    IF (pmrdat <> 255) AND (pmrdat <> 248) THEN
      PRINT USING "  [##]  "; x;
    ELSE
      IF pmrdat = 248 THEN
	COLOR 8, 7, 7
	PRINT USING "J [##]  "; x;
	COLOR dun, 7, 7
      END IF
    END IF
  NEXT x

chnlp:
  COLOR 15, 7, 7
  LOCATE 23, 16
  PRINT "   Enter Location (00-99) or ENTER to exit :     "
  LOCATE 25, 16

  y = 23
  x = 60
  T = 2
  GOSUB getnum

  IF jge = 1 THEN GOTO chnlp
   COLOR 15, 1, 1

    IF num$ <> "" THEN
      chan = VAL(num$)
      pmrdat = image(pmrfx!(chan), pmrfy!(chan))
      LOCATE 15, 16
      INPUT "   [F]requency or [J]ump or [D]elete ? "; a$
    
	IF a$ = "d" OR a$ = "D" THEN    'delete from list
	  image(pmrfx!(chan), pmrfy!(chan)) = 255
	  GOTO lndfrq
	ELSEIF a$ = "f" OR a$ = "F" THEN
	       IF (pmrdat <> 255) AND (pmrdat <> 248) THEN
		 GOSUB editpmr          'display them
	       ELSE
		 GOSUB enterpmr
	       END IF
	  GOTO lndfrq
	ELSE
	  LOCATE 16, 16
	  INPUT "   Enter Channel to Jump to :", chjmp
	  a = setlrx(&HF8, chjmp, chan)
	  GOTO lndfrq
	END IF
    END IF
  done = 0

RETURN

editpmr:
  CLS
  title

  LOCATE 4, 30
  COLOR 15, 8, 8
  PRINT USING "   CHANNEL ##   "; chan
  COLOR 15, 7, 7
  LOCATE 5, 25
  PRINT USING " Recieve Frequency  = ###.### "; rxpmr(chan)
  LOCATE 6, 25
  PRINT USING " Transmit Frequency = ###.### "; txpmr(chan)
  IF ctrxpmr(chan) <> 255 THEN
    LOCATE 7, 25
    PRINT USING " CTCSS RX Frequency = ###.#hz "; ctrxpmr(chan)
    LOCATE 8, 25
    PRINT USING " CTCSS TX Frequency = ###.#hz "; cttxpmr(chan)
    COLOR 15, 7, 7

  ELSE
    LOCATE 7, 25
    PRINT "     NO CTCSS programmed      "
    COLOR 15, 7, 7
  END IF

  COLOR 15, 8, 8
  LOCATE 21, 12
  PRINT "                  DATA OK ? (Y/N)                        "
  COLOR 15, 1, 1

illky4:
  GOSUB clrky
  WHILE i$ = ""
    i$ = INKEY$
  WEND
  IF i$ = "N" OR i$ = "n" THEN
    GOSUB enterpmr
  END IF

  COLOR 15, 1, 1

RETURN


enterpmr:
  CLS
  title
  LOCATE 4, 32
  COLOR 15, 8, 8
  PRINT USING "   CHANNEL ##   "; chan
  COLOR 15, 7, 7
  ctr = 22
epmr1:
  COLOR 15, 7, 7
  LOCATE 5, ctr
  PRINT " Recieve Frequency   ==>            "

  y = 5
  x = ctr + 25
  T = fint
  GOSUB getnum
  IF jge = 1 THEN GOTO epmr1
  GOSUB chkfrq1
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO epmr1
  END IF
  IF znum <> 0 THEN
    GOSUB makefrq
  ELSE
    frqh = 255
    frql = 255
  END IF

  a = setlrx(frqh, frql, chan)
  LOCATE 5, ctr + 24
  COLOR dun, 7, 7
  PRINT USING "  ###.#####"; znum
  COLOR 15, 7, 7

epmr2:
  COLOR 15, 7, 7
  LOCATE 6, ctr
  PRINT " Transmit Frequency  ==>            "

  y = 6
  x = ctr + 25
  T = fint
  GOSUB getnum
  IF jge = 1 THEN GOTO epmr2
  GOSUB chkfrq1
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO epmr2
  END IF

  IF znum <> 0 THEN
    GOSUB txmakefrq
  ELSE
    frqh = 255
    frqh = 255
  END IF

  a = setltx(frqh, frql, chan)
  LOCATE 6, ctr + 24
  COLOR dun, 7, 7
  PRINT USING "  ###.#####"; znum
  COLOR 15, 7, 7

  LOCATE 15, 1
  PRINT "    0 - NO TONE                                                                 "
  PRINT "    1 - 67.0hz   9 -  91.5hz  17 - 118.8hz  25 - 156.7hz  33 - 210.7hz          "
  PRINT "    2 - 71.9hz  10 -  94.8hz  18 - 123.0hz  26 - 162.2hz  34 - 218.1hz          "
  PRINT "    3 - 74.4hz  11 -  97.4hz  19 - 127.3hz  27 - 167.9hz  35 - 225.7hz          "
  PRINT "    4 - 77.0hz  12 - 100.0hz  20 - 131.8hz  28 - 173.8hz  36 - 233.6hz          "
  PRINT "    5 - 79.7hz  13 - 103.5hz  21 - 136.5hz  29 - 179.9hz  37 - 241.8hz          "
  PRINT "    6 - 82.5hz  14 - 107.2hz  22 - 141.3hz  30 - 186.2hz  38 - 250.3hz          "
  PRINT "    7 - 85.4hz  15 - 110.9hz  23 - 146.2hz  31 - 192.8hz                        "
  PRINT "    8 - 88.5hz  16 - 114.8hz  24 - 151.4hz  32 - 203.5hz                        "

epmr3:
  COLOR 15, 7, 7
  LOCATE 7, ctr
  PRINT " CTCSS RX Frequency  ==>            "

  y = 7
  x = ctr + 25
  T = 2
  GOSUB getnum
  IF jge = 1 THEN GOTO epmr3
  num = VAL(num$)
  IF num > 38 THEN
    PRINT CHR$(7)
    GOTO epmr3
  END IF
  a = setlctrx(chan, num)
  LOCATE 7, ctr + 24
  COLOR dun, 7, 7
  PRINT USING " ##"; num
  COLOR 15, 7, 7

epmr4:
  COLOR 15, 7, 7
  LOCATE 8, ctr
  PRINT " CTCSS TX Frequency  ==>            "

  y = 8
  x = ctr + 25
  T = 2
  GOSUB getnum
  IF jge = 1 THEN GOTO epmr4
  num = VAL(num$)
  IF num > 38 THEN
    PRINT CHR$(7)
    GOTO epmr4
  END IF
  a = setlcttx(chan, num)
  LOCATE 8, ctr + 24
  COLOR dun, 7, 7
  PRINT USING " ##"; num
  COLOR 15, 7, 7

  COLOR 15, 1, 1

RETURN


getton:
    LOCATE tony, tonx
    PRINT "==>       "
    y = tony
    x = tonx + 4
    T = 4
    GOSUB getnum                'get the number
    IF jge = 1 THEN GOTO getton
    tmin = 12.5
    tmax = 3187.5
    sp = 12.5
    GOSUB chktim                ' check and round the time
    IF errfg = 0 THEN
      PRINT CHR$(7)
      GOTO getton
    END IF
    LOCATE tony, tonx
    PRINT "   "; num;
RETURN


pmrdec:
  CLS
  title
  LOCATE 4, 19
  COLOR 15, 8, 8
  PRINT "  Low Frequency   High Frequency   Digit  "
  COLOR 15, 7, 7
  FOR x = 0 TO 17
  LOCATE 5 + x, 19
    PRINT "                                          "
  NEXT x
  FOR x = 0 TO 15
    LOCATE 6 + x, 22
    PRINT image(92, x) * 12.5
  NEXT x
  FOR x = 1 TO 15
    LOCATE 5 + x, 38
    PRINT image(93, x) * 12.5;
  NEXT x
  LOCATE 21, 38
  PRINT image(94, 0) * 12.5;
  FOR x = 2 TO 15
    LOCATE 4 + x, 55
    PRINT USING "\\"; HEX$(image(94, x));
  NEXT x
  LOCATE 20, 55
  PRINT USING "\\"; HEX$(image(95, 0));
  LOCATE 21, 55
  PRINT USING "\\"; HEX$(image(95, 1));

  COLOR 15, 8, 8
  FOR x = 0 TO 15
    LOCATE 6 + x, 16
    PRINT " "; CHR$(65 + x); " ";
  NEXT x
  LOCATE 23, 34
  PRINT " [F10] Done ";
  COLOR 15, 7, 7


  FOR x = 1 TO 25
    KEY(x) OFF
  NEXT x
  KEY(10) ON

  ON KEY(10) GOSUB golvl2

  dsp = 0
pgton1:
  i$ = ""
  WHILE i$ = ""
    IF dsp = 1 THEN
      RETURN
    END IF
    i$ = INKEY$
  WEND

  SELECT CASE i$

  CASE "A", "a"
  tony = 6
  tonx = 19
  GOSUB getton
  image(92, 0) = num / 12.5

  tony = 6
  tonx = 35
  GOSUB getton
  image(93, 1) = num / 12.5

  CASE "B", "b"
  tony = 7
  tonx = 19
  GOSUB getton
  image(92, 1) = num / 12.5

  tony = 7
  tonx = 35
  GOSUB getton
  image(93, 2) = num / 12.5

  CASE "C", "c"
  tony = 8
  tonx = 19
  GOSUB getton
  image(92, 2) = num / 12.5

  tony = 8
  tonx = 35
  GOSUB getton
  image(93, 3) = num / 12.5

  CASE "D", "d"
  tony = 9
  tonx = 19
  GOSUB getton
  image(92, 3) = num / 12.5

  tony = 9
  tonx = 35
  GOSUB getton
  image(93, 4) = num / 12.5

  CASE "E", "e"
  tony = 10
  tonx = 19
  GOSUB getton
  image(92, 4) = num / 12.5

  tony = 10
  tonx = 35
  GOSUB getton
  image(93, 5) = num / 12.5

  CASE "F", "f"
  tony = 11
  tonx = 19
  GOSUB getton
  image(92, 5) = num / 12.5

  tony = 11
  tonx = 35
  GOSUB getton
  image(93, 6) = num / 12.5

  CASE "G", "g"
  tony = 12
  tonx = 19
  GOSUB getton
  image(92, 6) = num / 12.5

  tony = 12
  tonx = 35
  GOSUB getton
  image(93, 7) = num / 12.5

  CASE "H", "h"
  tony = 13
  tonx = 19
  GOSUB getton
  image(92, 7) = num / 12.5

  tony = 13
  tonx = 35
  GOSUB getton
  image(93, 8) = num / 12.5

  CASE "I", "i"
  tony = 14
  tonx = 19
  GOSUB getton
  image(92, 8) = num / 12.5

  tony = 14
  tonx = 35
  GOSUB getton
  image(93, 9) = num / 12.5

  CASE "J", "j"
  tony = 15
  tonx = 19
  GOSUB getton
  image(92, 9) = num / 12.5

  tony = 15
  tonx = 35
  GOSUB getton
  image(93, 10) = num / 12.5

  CASE "K", "k"
  tony = 16
  tonx = 19
  GOSUB getton
  image(92, 10) = num / 12.5

  tony = 16
  tonx = 35
  GOSUB getton
  image(93, 11) = num / 12.5

  CASE "L", "l"
  tony = 17
  tonx = 19
  GOSUB getton
  image(92, 11) = num / 12.5

  tony = 17
  tonx = 35
  GOSUB getton
  image(93, 12) = num / 12.5

  CASE "M", "m"
  tony = 18
  tonx = 19
  GOSUB getton
  image(92, 12) = num / 12.5

  tony = 18
  tonx = 35
  GOSUB getton
  image(93, 13) = num / 12.5

  CASE "N", "n"
  tony = 19
  tonx = 19
  GOSUB getton
  image(92, 13) = num / 12.5

  tony = 19
  tonx = 35
  GOSUB getton
  image(93, 14) = num / 12.5

  CASE "O", "o"
  tony = 20
  tonx = 19
  GOSUB getton
  image(92, 14) = num / 12.5

  tony = 20
  tonx = 35
  GOSUB getton
  image(93, 15) = num / 12.5

  CASE "P", "p"
  tony = 21
  tonx = 19
  GOSUB getton
  image(92, 15) = num / 12.5

  tony = 21
  tonx = 35
  GOSUB getton
  image(94, 0) = num / 12.5

  CASE ELSE

  END SELECT

GOTO pgton1


chkton:
  num = VAL(num$)
  errfg = 1
  IF (num < tmin) OR (num > tmax) THEN
    errfg = 0
    RETURN
  END IF
  a = 1 / (num * 4.4699E-06)
  M = CINT(a)
  num = 1 / (M * 4.4699E-06)
RETURN

golvl2:
  dsp = 1
RETURN

getton1:
    LOCATE tony, tonx
    PRINT "==>       "
    y = tony
    x = tonx + 4
    T = 4
    GOSUB getnum                'get the number
    IF jge = 1 THEN GOTO getton1
    tmin = 0
    tmax = 3000
    GOSUB chkton
    IF errfg = 0 THEN
      PRINT CHR$(7)
      GOTO getton1
    END IF
    LOCATE tony, tonx
    PRINT "   "; num;
RETURN

pmrenc:
  CLS
  title

  ctr = 26
  LOCATE 4, ctr
  COLOR 15, 8, 8
  PRINT "  5/6/4 Tone encoder   Digit  "
  COLOR 15, 7, 7
  FOR x = 0 TO 18
  LOCATE 5 + x, ctr
    PRINT "                            "
  NEXT x
  FOR x = 3 TO 15
    LOCATE 3 + x, ctr + 7
    PRINT USING "####hz"; 1 / ((image(95, x) + 64) * 4.4699E-06)
  NEXT x
  LOCATE 19, ctr + 7
  PRINT USING "####hz"; 1 / ((image(96, 0) + 64) * 4.4699E-06)
  LOCATE 20, ctr + 7
  PRINT USING "####hz"; 1 / ((image(96, 1) + 64) * 4.4699E-06)

  FOR x = 0 TO 14
    LOCATE 6 + x, ctr + 23
    PRINT USING "!"; HEX$(x)
  NEXT x

  LOCATE 21, ctr + 2
  PRINT USING "Tone duration      ###ms"; image(96, 2) * 2.0025
  LOCATE 22, ctr + 2
  PRINT USING "Intertone gap      ###ms"; image(96, 3) * 2.0025
  LOCATE 23, ctr + 2
  PRINT USING "First Tone        ####ms"; image(96, 4) * 8.01

  COLOR 15, 8, 8
  FOR x = 0 TO 17
    LOCATE 6 + x, ctr - 5
    PRINT USING " [!] "; CHR$(65 + x)
  NEXT x
  LOCATE 24, 34
  PRINT " [F10] Done ";
  COLOR 15, 7, 7


  FOR x = 1 TO 25
    KEY(x) OFF
  NEXT x
  KEY(10) ON

  ON KEY(10) GOSUB golvl2

  dsp = 0
pgencd1:
  i$ = ""
  WHILE i$ = ""
    IF dsp = 1 THEN
      RETURN
    END IF
    i$ = INKEY$
  WEND

  SELECT CASE i$

  CASE "A", "a"
    tony = 6
    tonx = 19
    GOSUB getton1
    image(95, 3) = num - 64

  CASE "B", "b"
    tony = 7
    tonx = 19
    GOSUB getton1
    image(95, 4) = num - 64

  CASE "C", "c"
    tony = 8
    tonx = 19
    GOSUB getton1
    image(95, 5) = num - 64

  CASE "D", "d"
    tony = 9
    tonx = 19
    GOSUB getton1
    image(95, 6) = num - 64

  CASE "E", "e"
    tony = 10
    tonx = 19
    GOSUB getton1
    image(95, 7) = num - 64


  CASE "F", "f"
    tony = 11
    tonx = 19
    GOSUB getton1
    image(95, 8) = num - 64

  CASE "G", "g"
    tony = 12
    tonx = 19
    GOSUB getton1
    image(95, 9) = num - 64

  CASE "H", "h"
    tony = 13
    tonx = 19
    GOSUB getton1
    image(95, 10) = num - 64

  CASE "I", "i"
    tony = 14
    tonx = 19
    GOSUB getton1
    image(95, 11) = num - 64

  CASE "J", "j"
    tony = 15
    tonx = 19
    GOSUB getton1
    image(95, 12) = num - 64

  CASE "K", "k"
    tony = 16
    tonx = 19
    GOSUB getton1
    image(95, 13) = num - 64

  CASE "L", "l"
    tony = 17
    tonx = 19
    GOSUB getton1
    image(95, 14) = num - 64

  CASE "M", "m"
    tony = 18
    tonx = 19
    GOSUB getton1
    image(95, 15) = num - 64

  CASE "N", "n"
    tony = 19
    tonx = 19
    GOSUB getton1
    image(96, 0) = num - 64

  CASE "O", "o"
    tony = 20
    tonx = 19
    GOSUB getton1
    image(96, 1) = num - 64

  CASE "P", "p"
    y = 21
    x = ctr + 21
    T = 3
    GOSUB gettim
    image(96, 2) = CINT(num / 2.0025)

  CASE "Q", "q"
    y = 22
    x = ctr + 21
    T = 3
    GOSUB gettim
    image(96, 3) = CINT(num / 2.0025)

  CASE "R", "r"
    y = 23
    x = ctr + 20
    T = 4
labl1:
    LOCATE y, x - 3
    PRINT "==>      ";
    GOSUB getnum                'get the number
    IF jge = 1 THEN GOTO labl1
    tmin = 8.01                 '****************************
    tmax = 2042.55
    sp = 8.01
    GOSUB chktim                ' check and round the time
    IF errfg = 0 THEN
      PRINT CHR$(7)             ' beep
      GOTO labl1
    END IF
    LOCATE y, x - 7
    PRINT USING "   ####ms"; num
    image(96, 4) = CINT(num / 8.01)

  CASE ELSE
    PRINT CHR$(7)

  END SELECT

GOTO pgencd1

gettim:
  LOCATE y, x - 3
  PRINT "==>     ";
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO gettim
  tmin = 2.0025
  tmax = 510.6375
  sp = 2.0025
  GOSUB chktim                ' check and round the time
  IF errfg = 0 THEN
    PRINT CHR$(7)             ' beep
    GOTO gettim
  END IF
  LOCATE y, x - 6
  PRINT USING "   ###ms"; num
RETURN

'****************** arp parameter

prgarp:
  FOR x = 1 TO 16
    KEY(x) OFF
  NEXT x
  dsp = 1
  CLS
  title
  ctr = 10
  COLOR 15, 8, 8
  LOCATE 6, ctr
  PRINT "                      ARP parameters                     "
  COLOR 15, 7, 7
  ' CHECK FIRST DIGIT OF ID
  IF image(18, 6) <> 255 THEN
     GOSUB shwarp
     GOTO isarpok
  END IF
  arp = 1
  image(18, 4) = image(18, 4) OR 32         'allow arp mode

  GOSUB arp1

  GOSUB arp2

  GOSUB arp3

  GOSUB arp4

  GOSUB arp5

  GOSUB arp6

  GOSUB shwbat

  ctra = 13
  GOSUB batsav1
  image(19, 1) = num / 10

  GOSUB batsav2
  image(19, 0) = num / 10               ' number recieved

  GOSUB batsav3
  image(19, 2) = num

  GOSUB clrbot

isarpok:
  COLOR 15, 8, 8
  LOCATE 21, ctr
  PRINT "                  DATA OK ? (Y/N)                        "

illky1:
  GOSUB clrky
  WHILE i$ = ""
    i$ = INKEY$
  WEND
  IF i$ = "N" OR i$ = "n" THEN
     COLOR 15, 8, 8
     FOR x = 7 TO 15
       LOCATE x, ctr - 5
       PRINT USING " [!] "; CHR$(x + 58)
     NEXT x
     LOCATE 7, ctr + 59
     PRINT " [F10] DONE"
     COLOR 15, 7, 7
     FOR x = 1 TO 25
       KEY(x) OFF
     NEXT x
     ON KEY(10) GOSUB goarpv

     KEY(10) ON
     COLOR 15, 1, 1
     LOCATE 21, ctr
     PRINT "                                                         "
     COLOR 15, 7, 7

     imdun = 0
     WHILE imdun = 0
       i$ = INKEY$
       IF i$ <> "" THEN
	 SELECT CASE i$

	 CASE "A", "a"
	   GOSUB arp1

	 CASE "B", "b"
	   GOSUB arp2

	 CASE "C", "c"
	   GOSUB arp3

	 CASE "D", "d"
	   GOSUB arp4

	 CASE "E", "e"
	   GOSUB arp5

	 CASE "F", "f"
	   GOSUB arp6

	 CASE "G", "g"
	   GOSUB arpbat1

	 CASE "H", "h"
	   GOSUB arpbat2

	 CASE "I", "i"
	   GOSUB arpbat3

	 CASE ELSE
	   PRINT CHR$(7)

	 END SELECT

       END IF

     WEND

     COLOR 15, 1, 1
     FOR x = 11 TO 19
       LOCATE x, ctr - 5
       PRINT "     "
     NEXT x
     LOCATE 20, ctr - 7
     PRINT "           "
'     GOTO isarpok
     i$ = "Y"
   END IF
   IF i$ <> "Y" AND i$ <> "y" THEN GOTO illky1

RETURN

arpbat1:
  GOSUB batsav1a
  image(19, 1) = num / 10
RETURN

arpbat2:
  GOSUB batsav2a
  image(19, 0) = num / 10
RETURN

arpbat3:
  GOSUB batsav3a
  image(19, 2) = num
RETURN


goarpv:
     imdun = 1
RETURN

'******************* land parameter
prglnd:
  FOR x = 1 TO 16
    KEY(x) OFF
  NEXT x
  dsp = 1
  CLS
  title
  ctr = 10
  COLOR 15, 8, 8
  LOCATE 3, ctr
  PRINT "                  LAND MOBILE parameters                 "
  COLOR 15, 7, 7
  ' CHECK LAND MOBILE OPTIONS
  IF image(19, 9) <> 255 THEN
    GOSUB shwpmr
    GOTO ispmrok
  END IF
  pmr = 1
  image(18, 4) = image(18, 4) OR 64         'allow land mobile mode

  GOSUB pmr1

  GOSUB pmr10

  GOSUB pmr11

  GOSUB pmr13

  GOSUB pmr12

  GOSUB pmr2a

  GOSUB pmr2

  GOSUB pmr3

  GOSUB pmr4

  GOSUB clrbot

  GOSUB shwdul

  GOSUB pmr5

  GOSUB pmr6

  GOSUB clrbot

  GOSUB pmr7

  GOSUB pmr8

  GOSUB pmr9

  GOSUB shwbat

  ctra = 18
  GOSUB batsav1
  image(20, 0) = num / 10

  GOSUB batsav2
  image(19, 15) = num / 10

  GOSUB batsav3
  image(20, 1) = num

  GOSUB clrbot

ispmrok:
  COLOR 15, 8, 8
  LOCATE 21, ctr
  PRINT "                  DATA OK ? (Y/N)                        "

illky2:
  GOSUB clrky
  WHILE i$ = ""
    i$ = INKEY$
  WEND
  IF i$ = "N" OR i$ = "n" THEN

     FOR x = 4 TO 20
       LOCATE x, ctr - 5
       PRINT USING " [!] "; CHR$(x + 61)
     NEXT x

     LOCATE 4, ctr + 59
     PRINT " [F10] DONE"
     COLOR 15, 7, 7

     FOR x = 1 TO 25
       KEY(x) OFF
     NEXT x
     ON KEY(10) GOSUB goarpv
     KEY(10) ON

     COLOR 15, 1, 1
     LOCATE 21, ctr
     PRINT "                                                         "

     imdun = 0
     WHILE imdun = 0
       i$ = INKEY$
       IF i$ <> "" THEN

	 SELECT CASE i$
	   CASE "A", "a"
	     GOSUB pmr1a

	   CASE "B", "b"
	     GOSUB pmr10a

	   CASE "C", "c"
	     GOSUB pmr11a

	   CASE "D", "d"
	     GOSUB pmr13a

	   CASE "E", "e"
	     GOSUB pmr12a

	   CASE "F", "f"
	     GOSUB pmr2b

	   CASE "G", "g"
	     GOSUB pmr2c

	   CASE "H", "h"
	     GOSUB pmr3a

	   CASE "I", "i"
	     GOSUB pmr4a

	   CASE "J", "j"
	     GOSUB pmr5a

	   CASE "K", "k"
	     GOSUB pmr6a

	   CASE "L", "l"
	     GOSUB pmr7a

	   CASE "M", "m"
	     GOSUB pmr8a

	   CASE "N", "n"
	     GOSUB pmr9a

	   CASE "O", "o"
	     GOSUB pmrbat1

	   CASE "P", "p"
	     GOSUB pmrbat2

	   CASE "Q", "q"
	     GOSUB pmrbat3

	   CASE ELSE
	     PRINT CHR$(7)

	 END SELECT
       END IF

     WEND

     KEY(10) OFF

     COLOR 15, 1, 1
     FOR x = 6 TO 15
       LOCATE x, ctr - 7
       PRINT "       "
     NEXT x
     LOCATE 16, ctr - 7
     PRINT "           "
'     GOTO ispmrok
     i$ = "Y"
   END IF
   IF i$ <> "Y" AND i$ <> "y" THEN GOTO illky2

RETURN

pmrbat1:
  GOSUB batsav1a
  image(20, 0) = num / 10
RETURN

pmrbat2:
  GOSUB batsav2a
  image(19, 15) = num / 10
RETURN

pmrbat3:
  GOSUB batsav3a
  image(20, 1) = num
RETURN

'################## marine parameter
prgmar:
  FOR x = 1 TO 16
    KEY(x) OFF
  NEXT x
  dsp = 1
  CLS
  title
  ctr = 10
  COLOR 15, 8, 8
  LOCATE 5, ctr
  PRINT "                     MARINE parameters                   "
  COLOR 15, 7, 7
  ' CHECK MARINE SCAN OPTIONS
  IF image(20, 4) <> 255 THEN
     GOSUB shwmar
     GOTO ismarok
  END IF
  mar = 1
  image(18, 4) = image(18, 4) OR 128

  GOSUB mar10

  GOSUB mar1

  GOSUB mar2

  GOSUB mar3

  GOSUB mar4

  GOSUB clrbot

  GOSUB shwdul

  GOSUB mar5

  GOSUB mar6

'  GOSUB clrbot

  GOSUB shwbat

  ctra = 13
  GOSUB batsav1
  image(20, 11) = num / 10

  GOSUB batsav2
  image(20, 10) = num / 10

  GOSUB batsav3
  image(20, 12) = num

  GOSUB clrbot

ismarok:
  COLOR 15, 8, 8
  LOCATE 21, ctr
  PRINT "                  DATA OK ? (Y/N)                        "
  COLOR 15, 1, 1

illky3:
  GOSUB clrky
  WHILE i$ = "" AND i$ <> "Y" AND i$ <> "y" AND i$ <> "N" AND i$ <> "n"
    i$ = INKEY$
  WEND
  IF i$ = "N" OR i$ = "n" THEN

     COLOR 15, 8, 8
     FOR x = 6 TO 15
       LOCATE x, ctr - 5
       PRINT USING " [!] "; CHR$(x + 59)
     NEXT x

     LOCATE 6, ctr + 59
     PRINT " [F10] DONE"
     COLOR 15, 7, 7

     ON KEY(10) GOSUB goarpv
     KEY(10) ON

     COLOR 15, 1, 1
     LOCATE 21, ctr
     PRINT "                                                         "

     imdun = 0
     WHILE imdun = 0
       i$ = INKEY$
       IF i$ <> "" THEN
	 SELECT CASE i$
	   CASE "A", "a"
	     GOSUB mar10a

	   CASE "B", "b"
	     GOSUB mar1a

	   CASE "C", "c"
	     GOSUB mar2a

	   CASE "D", "d"
	     GOSUB mar3a

	   CASE "E", "e"
	     GOSUB mar4a

	   CASE "F", "f"
	     GOSUB mar5a

	   CASE "G", "g"
	     GOSUB mar6a

	   CASE "H", "h"
	     GOSUB marbat1

	   CASE "I", "i"
	     GOSUB marbat2

	   CASE "J", "j"
	     GOSUB marbat3

	   CASE ELSE
	     PRINT CHR$(7)

	 END SELECT

       END IF
     WEND

     KEY(10) OFF

     COLOR 15, 1, 1

     FOR x = 11 TO 19
       LOCATE x, ctr - 7
       PRINT "       "
     NEXT x

     LOCATE 8, ctr + 59
     PRINT "           "

'     GOTO ismarok
     i$ = "Y"
   END IF
   IF i$ <> "Y" AND i$ <> "y" THEN GOTO illky3

  dsp = 1
  CLS
  title
  ctr = 10
  COLOR 15, 8, 8
  LOCATE 5, ctr
  PRINT "              MARINE frequency Programming                "
  COLOR 15, 7, 7

  ctry = 6
  dtyp = 1
  frqh = image(37, 14)
  frql = image(37, 15)
  stat = image(38, 1)
  chan = image(38, 0)
  GOSUB dspstat

  ctry = ctry + 1
  dtyp = 2
  frqh = image(51, 14)
  frql = image(51, 15)
  stat = image(52, 1)
  chan = image(52, 0)
  GOSUB dspstat

  ctry = ctry + 1
  dtyp = 3
  frqh = image(52, 2)
  frql = image(52, 3)
  stat = image(52, 5)
  chan = image(52, 4)
  GOSUB dspstat

  ctry = ctry + 1
  dtyp = 4
  frqh = image(52, 6)
  frql = image(52, 7)
  stat = image(52, 9)
  chan = image(52, 8)
  GOSUB dspstat

  ctry = ctry + 1
  dtyp = 5
  frqh = image(52, 10)
  frql = image(52, 11)
  stat = image(52, 13)
  chan = image(52, 12)
  GOSUB dspstat

  ctry = ctry + 1
  dtyp = 6
  frqh = image(52, 14)
  frql = image(52, 15)
  stat = image(53, 1)
  chan = image(53, 0)
  GOSUB dspstat

  ctry = ctry + 1
  dtyp = 7
  frqh = image(53, 2)
  frql = image(53, 3)
  stat = image(53, 5)
  chan = image(53, 4)
  GOSUB dspstat

     COLOR 15, 8, 8
     FOR x = 6 TO 12
       LOCATE x, ctr - 7
       PRINT USING " [F##] "; x - 5
     NEXT x
     LOCATE 14, ctr - 7
     PRINT " [F10] DONE"
     COLOR 15, 7, 7

     FOR x = 1 TO 7
       KEY(x) ON
     NEXT x
     FOR x = 8 TO 16
       KEY(x) OFF
     NEXT x
     KEY(10) ON

     COLOR 15, 1, 1
     LOCATE 21, ctr
     PRINT "                                                         "

     ON KEY(1) GOSUB mar21
     ON KEY(2) GOSUB mar22
     ON KEY(3) GOSUB mar23
     ON KEY(4) GOSUB mar24
     ON KEY(5) GOSUB mar25
     ON KEY(6) GOSUB mar26
     ON KEY(7) GOSUB mar27
     ON KEY(10) GOSUB goarpv
     imdun = 0
     WHILE imdun = 0
     WEND

     FOR x = 1 TO 16
       KEY(x) OFF
     NEXT x

     COLOR 15, 1, 1
     FOR x = 11 TO 19
       LOCATE x, ctr - 7
       PRINT "       "
     NEXT x
     LOCATE 20, ctr - 7
     PRINT "           "

RETURN

marbat1:
  GOSUB batsav1a
  image(20, 11) = num / 10
RETURN

marbat2:
  GOSUB batsav2a
  image(20, 10) = num / 10
RETURN

marbat3:
  GOSUB batsav3a
  image(20, 12) = num
RETURN

'############# arp parameter
shwarp:
  GOSUB a5dig
  num$ = ""
  FOR x = 6 TO 10
    num$ = num$ + CHR$(image(18, x) + 48)
  NEXT x
  LOCATE 7, ctr + 50
  COLOR dun, 7, 7
  PRINT ""; num$
  COLOR 15, 7, 7

  GOSUB absy
  LOCATE 8, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "   ##"; image(18, 11)
  COLOR 15, 7, 7

  GOSUB afree
  LOCATE 9, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "   ##"; image(18, 12)
  COLOR 15, 7, 7

  GOSUB aopen
  LOCATE 10, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "   ##"; image(18, 13)
  COLOR 15, 7, 7

  GOSUB apause
  LOCATE 11, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "   ##"; image(18, 14)
  COLOR 15, 7, 7

  GOSUB asid
  LOCATE 12, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; image(18, 15) + 1
  COLOR 15, 7, 7

  ctra = 13
  GOSUB abat1
  LOCATE ctra, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(19, 1) * 10
  COLOR 15, 7, 7

  GOSUB abat2
  LOCATE ctra + 1, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(19, 0) * 10
  COLOR 15, 7, 7

  GOSUB abat3
  LOCATE ctra + 2, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "  ###"; image(19, 2)
  COLOR 15, 7, 7

RETURN



arp1:
  GOSUB a5dig
  y = 7
  x = ctr + 50
  T = 5                                 ' get 5 digits
  GOSUB getnum
  IF jge = 1 THEN GOTO arp1
  IF LEN(num$) < 5 THEN GOTO arp1       ' too short
  LOCATE 7, ctr + 50
  COLOR dun, 7, 7
  PRINT ""; num$
  COLOR 15, 7, 7
  FOR x = 1 TO 5
    a = ASC(MID$(num$, x, 1)) - 48
    image(18, 5 + x) = a
  NEXT x

RETURN

arp2:
  GOSUB absy
  y = 8
  x = ctr + 50
  T = 2
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO arp2
  tmin = 1
  tmax = 10
  sp = 1
  GOSUB chktim                ' check and round the time
  IF errfg = 0 THEN
    PRINT CHR$(7)             ' beep
    GOTO arp2
  END IF
  LOCATE 8, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "   ##"; num
  COLOR 15, 7, 7
  image(18, 11) = num                   ' busy tone time
RETURN


arp3:
  GOSUB afree
  y = 9
  x = ctr + 50
  T = 2
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO arp3
  tmin = 1
  tmax = 10
  sp = 1
  GOSUB chktim                ' check and round the time
  IF errfg = 0 THEN
    PRINT CHR$(7)             ' beep
    GOTO arp3
  END IF
  LOCATE 9, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "   ##"; num
  COLOR 15, 7, 7
  image(18, 12) = num                   ' number recieved
RETURN


arp4:
  GOSUB aopen
  y = 10
  x = ctr + 50
  T = 2
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO arp4
  tmin = 1
  tmax = 10
  sp = 1
  GOSUB chktim                ' check and round the time
  IF errfg = 0 THEN
    PRINT CHR$(7)             ' beep
    GOTO arp4
  END IF
  LOCATE 10, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "   ##"; num
  COLOR 15, 7, 7
  image(18, 13) = num                   ' number recieved
RETURN


arp5:
  GOSUB apause
  y = 11
  x = ctr + 50
  T = 2
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO arp5
  tmin = 1
  tmax = 10
  sp = 1
  GOSUB chktim                ' check and round the time
  IF errfg = 0 THEN
    PRINT CHR$(7)             ' beep
    GOTO arp5
  END IF
  LOCATE 11, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "   ##"; num
  COLOR 15, 7, 7
  image(18, 14) = num                   ' number recieved
RETURN


arp6:
  GOSUB asid
  y = 12
  x = ctr + 50
  T = 1
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO arp6
  num = VAL(num$)
  IF num < 1 OR num > 2 THEN GOTO arp6
  LOCATE 12, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(18, 15) = num - 1
RETURN


'########### land parameter
shwpmr:
  GOSUB lid
  num$ = ""
  FOR x = 1 TO 6
    IF image(19, 2 + x) <> 255 THEN
      num$ = num$ + CHR$(image(19, 2 + x) + 48)
    END IF
  NEXT x
  LOCATE 4, ctr + 50
  COLOR dun, 7, 7
  PRINT ""; num$
  COLOR 15, 7, 7

  GOSUB ltxt
  LOCATE 5, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(19, 9) AND 24) / 8) + 1
  COLOR 15, 7, 7

  GOSUB lctcss
  LOCATE 6, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(19, 9) AND 32) / 32) + 1
  COLOR 15, 7, 7

  GOSUB actlck
  LOCATE 7, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(19, 9) AND 128) / 128) + 1
  COLOR 15, 7, 7

  GOSUB lrts
  LOCATE 8, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(19, 9) AND 64) / 64) + 1
  COLOR 15, 7, 7

  GOSUB lscndr
  LOCATE 9, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(19, 9) AND 4) / 4) + 1
  COLOR 15, 7, 7

  GOSUB lscntp
  LOCATE 10, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; (image(19, 9) AND 3) + 1
  COLOR 15, 7, 7

  GOSUB lscntm
  LOCATE 11, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(19, 12) * 10
  COLOR 15, 7, 7

  GOSUB lscndl
  LOCATE 12, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(19, 13) * 10
  COLOR 15, 7, 7

  GOSUB ldulm
  LOCATE 13, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "#####"; image(19, 10) * 50
  COLOR 15, 7, 7

  GOSUB ldulp
  LOCATE 14, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(19, 11) * 10
  COLOR 15, 7, 7

  GOSUB rtslstn
  LOCATE 15, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "  ###"; image(20, 2)
  COLOR 15, 7, 7

  GOSUB rtsact
  LOCATE 16, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "  ###"; image(20, 3)
  COLOR 15, 7, 7

  GOSUB ctcdly
  LOCATE 17, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(19, 14) * 10'************************
  COLOR 15, 7, 7

  ctra = 18
  GOSUB abat1
  LOCATE ctra, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 0) * 10
  COLOR 15, 7, 7

  GOSUB abat2
  LOCATE ctra + 1, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(19, 15) * 10
  COLOR 15, 7, 7

  GOSUB abat3
  LOCATE ctra + 2, ctr + 50     '****************** 2 ?
  COLOR dun, 7, 7
  PRINT USING "  ###"; image(20, 1)
  COLOR 15, 7, 7


RETURN


pmr1a:
  GOSUB clrbot
pmr1:
  GOSUB lid
  y = 4
  x = ctr + 50
  T = 6                                 ' get 4/5/6 digits
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr1
  IF LEN(num$) < 4 THEN GOTO pmr1       ' too short
  LOCATE 4, ctr + 50
  COLOR dun, 7, 7
  PRINT ""; num$
  COLOR 15, 7, 7
  WHILE LEN(num$) < 6
    num$ = CHR$(255) + num$
  WEND
  FOR x = 1 TO 6
    a = ASC(MID$(num$, x, 1))
    IF a <> 255 THEN a = a - 48
    image(19, 2 + x) = a
  NEXT x

RETURN


pmr10a:
  GOSUB clrbot
pmr10:
  GOSUB ltxt
  y = 5
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr10
  num = VAL(num$)
  IF num < 1 OR num > 4 THEN GOTO pmr10
  LOCATE 5, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(19, 9) = image(19, 9) AND 231
  image(19, 9) = image(19, 9) + ((num - 1) * 8)
RETURN

pmr11a:
  GOSUB clrbot
pmr11:
  GOSUB lctcss
  y = 6
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr11
  num = VAL(num$)
  IF num < 1 OR num > 2 THEN GOTO pmr11
  LOCATE 6, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(19, 9) = image(19, 9) AND 223
  image(19, 9) = image(19, 9) + ((num - 1) * 32)
RETURN


pmr12a:
  GOSUB clrbot
pmr12:
  GOSUB lrts
  y = 8
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr12
  num = VAL(num$)
  IF num < 1 OR num > 2 THEN GOTO pmr12
  LOCATE 8, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(19, 9) = image(19, 9) AND 191
  image(19, 9) = image(19, 9) + ((num - 1) * 64)
RETURN


pmr2b:
  GOSUB clrbot
pmr2a:
  GOSUB lscndr
  y = 9
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr2a
  num = VAL(num$)
  IF num < 1 OR num > 2 THEN GOTO pmr2a
  LOCATE 9, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(19, 9) = image(19, 9) AND 251
  image(19, 9) = image(19, 9) + ((num - 1) * 4)
RETURN

pmr2c:
  GOSUB clrbot
pmr2:
  GOSUB lscntp
  y = 10
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr2
  num = VAL(num$)
  IF num < 1 OR num > 3 THEN GOTO pmr2
  LOCATE 10, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(19, 9) = image(19, 9) AND 252
  image(19, 9) = image(19, 9) + (num - 1)
  IF (image(19, 9) AND 3) = 0 THEN GOSUB scana             ' show the scan types
  IF (image(19, 9) AND 3) = 1 THEN GOSUB scanb
  IF (image(19, 9) AND 3) = 2 THEN GOSUB scanc
RETURN


pmr3a:
  IF (image(19, 9) AND 3) = 0 THEN GOSUB scana             ' show the scan types
  IF (image(19, 9) AND 3) = 1 THEN GOSUB scanb
  IF (image(19, 9) AND 3) = 2 THEN GOSUB scanc
pmr3:
  GOSUB lscntm
  y = 11
  x = ctr + 50
  T = 4
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr3
  tmin = 10
  tmax = 2550
  sp = 10
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO pmr3
  END IF
  LOCATE 11, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(19, 12) = num / 10
RETURN


pmr4a:
  IF (image(19, 9) AND 3) = 0 THEN GOSUB scana             ' show the scan types
  IF (image(19, 9) AND 3) = 1 THEN GOSUB scanb
  IF (image(19, 9) AND 3) = 2 THEN GOSUB scanc
pmr4:
  GOSUB lscndl
  y = 12
  x = ctr + 50
  T = 4
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr4
  tmin = 10
  tmax = 2550
  sp = 10
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO pmr4
  END IF
  LOCATE 12, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(19, 13) = num / 10
RETURN


pmr5a:
  GOSUB shwdul
pmr5:
  GOSUB ldulm
  y = 13
  x = ctr + 50
  T = 5
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr5
  tmin = 50
  tmax = 12750
  sp = 50
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO pmr5
  END IF
  LOCATE 13, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "#####"; num
  COLOR 15, 7, 7
  image(19, 10) = num / 50
RETURN


pmr6a:
  GOSUB shwdul
pmr6:
  GOSUB ldulp
  y = 14
  x = ctr + 50
  T = 4
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr6
  tmin = 10
  tmax = 2550
  sp = 10
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO pmr6
  END IF
  LOCATE 14, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(19, 11) = num / 10
RETURN

pmr7a:
  GOSUB clrbot
pmr7:
  GOSUB rtslstn
  y = 15
  x = ctr + 50
  T = 3
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr7
  tmin = 1
  tmax = 255
  sp = 1
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO pmr7
  END IF
  LOCATE 15, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(20, 2) = num
RETURN

pmr8a:
  GOSUB clrbot
pmr8:
  GOSUB rtsact
  y = 16
  x = ctr + 50
  T = 3
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr8
  tmin = 1
  tmax = 255
  sp = 1
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO pmr8
  END IF
  LOCATE 16, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(20, 3) = num
RETURN

pmr9a:
  GOSUB clrbot
pmr9:
  GOSUB ctcdly
  y = 17
  x = ctr + 50
  T = 3
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr9
  tmin = 10
  tmax = 2550
  sp = 10
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO pmr9
  END IF
  LOCATE 17, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(19, 14) = num '/10   ********************************
RETURN

pmr13a:
  GOSUB clrbot
pmr13:
  GOSUB actlck
  y = 7
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr13
  num = VAL(num$)
  IF num < 1 OR num > 2 THEN
    PRINT CHR$(7)
    GOTO pmr13
  END IF
  LOCATE 7, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(19, 9) = image(19, 9) AND 127
  image(19, 9) = image(19, 9) + ((num - 1) * 128)
RETURN

'############ marine
shwmar:
  GOSUB mtxt
  LOCATE 6, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(20, 4) AND 24) / 8) + 1
  COLOR 15, 7, 7

  GOSUB mscndr
  LOCATE 7, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(20, 4) AND 4) / 4) + 1
  COLOR 15, 7, 7

  GOSUB mscntp
  LOCATE 8, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; (image(20, 4) AND 3) + 1
  COLOR 15, 7, 7

  GOSUB mscnrt
  LOCATE 9, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 7) * 10
  COLOR 15, 7, 7

  GOSUB mscndl
  LOCATE 10, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 8) * 10
  COLOR 15, 7, 7

  GOSUB mdulm
  LOCATE 11, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "#####"; image(20, 5) * 50
  COLOR 15, 7, 7

  GOSUB mdulp
  LOCATE 12, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 6) * 10
  COLOR 15, 7, 7

  ctra = 13
  GOSUB abat1
  LOCATE ctra, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 11) * 10
  COLOR 15, 7, 7

  GOSUB abat2
  LOCATE ctra + 1, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 10) * 10
  COLOR 15, 7, 7

  GOSUB abat3
  LOCATE ctra + 2, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "  ###"; image(20, 12)
  COLOR 15, 7, 7

RETURN

mar10a:
  GOSUB clrbot
mar10:
  GOSUB mtxt
  y = 6
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO pmr10
  num = VAL(num$)
  IF num < 1 OR num > 4 THEN GOTO pmr10
  LOCATE 6, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(20, 4) = image(20, 4) AND 231
  image(20, 4) = image(20, 4) + ((num - 1) * 8)
RETURN


mar1a:
  GOSUB clrbot
mar1:
  GOSUB mscndr
  y = 7
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO mar1
  num = VAL(num$)
  IF num < 1 OR num > 2 THEN GOTO mar1
  LOCATE 7, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(20, 4) = image(20, 4) AND 251
  image(20, 4) = (num - 1) * 4
RETURN


mar2a:
  GOSUB clrbot
mar2:
  GOSUB mscntp
  y = 8
  x = ctr + 50
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO mar2
  num = VAL(num$)
  IF num < 1 OR num > 3 THEN GOTO mar2
  LOCATE 8, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; num
  COLOR 15, 7, 7
  image(20, 4) = image(20, 4) AND 252
  image(20, 4) = image(20, 4) + (num - 1)
  IF (image(20, 4) AND 3) = 0 THEN GOSUB scana             ' show the scan types
  IF (image(20, 4) AND 3) = 1 THEN GOSUB scanb
  IF (image(20, 4) AND 3) = 2 THEN GOSUB scanc
RETURN


mar3a:
  IF (image(20, 4) AND 3) = 0 THEN GOSUB scana             ' show the scan types
  IF (image(20, 4) AND 3) = 1 THEN GOSUB scanb
  IF (image(20, 4) AND 3) = 2 THEN GOSUB scanc
mar3:
  GOSUB mscnrt
  y = 9
  x = ctr + 50
  T = 4
  GOSUB getnum
  IF jge = 1 THEN GOTO mar3
  tmin = 10
  tmax = 2550
  sp = 10
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO mar3
  END IF
  LOCATE 9, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(20, 7) = num / 10
RETURN


mar4a:
  IF (image(20, 4) AND 3) = 0 THEN GOSUB scana             ' show the scan types
  IF (image(20, 4) AND 3) = 1 THEN GOSUB scanb
  IF (image(20, 4) AND 3) = 2 THEN GOSUB scanc
mar4:
  GOSUB mscndl
  y = 10
  x = ctr + 50
  T = 4
  GOSUB getnum
  IF jge = 1 THEN GOTO mar4
  tmin = 10
  tmax = 2550
  sp = 10
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO mar4
  END IF
  LOCATE 10, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(20, 8) = num / 10
RETURN

mar5a:
  GOSUB shwdul
mar5:
  GOSUB mdulm
  y = 11
  x = ctr + 50
  T = 5
  GOSUB getnum
  IF jge = 1 THEN GOTO mar5
  tmin = 50
  tmax = 12750
  sp = 50
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO mar5
  END IF
  LOCATE 11, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "#####"; num
  COLOR 15, 7, 7
  image(20, 5) = num / 50
RETURN


mar6a:
  GOSUB shwdul
mar6:
  GOSUB mdulp
  y = 12
  x = ctr + 50
  T = 4
  GOSUB getnum
  IF jge = 1 THEN GOTO mar6
  tmin = 10
  tmax = 2550
  sp = 10
  GOSUB chktim
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO mar6
  END IF
  LOCATE 12, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7
  image(20, 6) = num / 10
RETURN


shwmar1:
  GOSUB mtxt
  LOCATE 6, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(20, 4) AND 24) / 8) + 1
  COLOR 15, 7, 7

  GOSUB mscndr
  LOCATE 7, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; ((image(20, 4) AND 4) / 4) + 1
  COLOR 15, 7, 7

  GOSUB mscntp
  LOCATE 8, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "    #"; (image(20, 4) AND 3) + 1
  COLOR 15, 7, 7

  GOSUB mscnrt
  LOCATE 9, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 7) * 10
  COLOR 15, 7, 7

  GOSUB mscndl
  LOCATE 10, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 8) * 10
  COLOR 15, 7, 7

  GOSUB mdulm
  LOCATE 11, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "#####"; image(20, 5) * 50
  COLOR 15, 7, 7

  GOSUB mdulp
  LOCATE 12, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 6) * 10
  COLOR 15, 7, 7

  ctra = 13
  GOSUB abat1
  LOCATE ctra, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 11) * 10
  COLOR 15, 7, 7

  GOSUB abat2
  LOCATE ctra + 1, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; image(20, 10) * 10
  COLOR 15, 7, 7

  GOSUB abat3
  LOCATE ctra + 2, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "  ###"; image(20, 12)
  COLOR 15, 7, 7

RETURN

gtmfreq:
  COLOR 15, 7, 7
  IF dtyp = 1 THEN GOSUB march00
  IF dtyp = 2 THEN GOSUB marchP1
  IF dtyp = 3 THEN GOSUB marchP2
  IF dtyp = 4 THEN GOSUB marchP3
  IF dtyp = 5 THEN GOSUB marchp4
  IF dtyp = 6 THEN GOSUB marchP5
  IF dtyp = 7 THEN GOSUB marchP6
  y = ctry
  x = ctr + 47
  T = fint
  GOSUB getnum
  IF jge = 1 THEN GOTO gtmfreq
  GOSUB chkfrq1
  IF errfg = 0 THEN
    PRINT CHR$(7)
    GOTO gtmfreq
  END IF
  LOCATE ctry, ctr + 46
  COLOR dun, 7, 7
  PRINT USING " ###.#####"; znum
  COLOR 15, 7, 7
RETURN

gtmsim:
  GOSUB march00a
  y = 20
  x = ctr + 47
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO gtmsim
  num = VAL(num$)
  IF num < 1 OR num > 2 THEN
    PRINT CHR$(7)
    GOTO gtmsim
  END IF
  LOCATE ctry, ctr + 18
  COLOR dun, 7, 7
  IF num = 1 THEN
    PRINT "Simplex"
  ELSE
    PRINT "Duplex "
  END IF
  COLOR 15, 7, 7
RETURN


gtmpwr:
  GOSUB march00b
  y = 21
  x = ctr + 47
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO gtmpwr
  num = VAL(num$)
  IF num < 1 OR num > 3 THEN
    PRINT CHR$(7)
    GOTO gtmpwr
  END IF
  LOCATE ctry, ctr + 28
  COLOR dun, 7, 7
  IF num = 1 THEN PRINT "Full PWR"
  IF num = 2 THEN PRINT "1W ONLY "
  IF num = 3 THEN PRINT "NO TX   "
  COLOR 15, 7, 7

RETURN


gtmchn:

  GOSUB marchPxc
  y = 22
  x = ctr + 47
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO gtmchn
  num = VAL(num$)
  IF num < 1 OR num > 3 THEN
    PRINT CHR$(7)
    GOTO gtmchn
  END IF
  LOCATE ctry, ctr + 4
  COLOR dun, 7, 7
  IF num = 1 THEN
    IF dtyp < 5 THEN
      PRINT "L"
    ELSE
      PRINT "F"
    END IF
  END IF
  IF num = 2 THEN PRINT "P"

  COLOR 15, 1, 1
  LOCATE 20, ctr
  PRINT "                                                           "
  LOCATE 21, ctr
  PRINT "                                                           "
  LOCATE 22, ctr
  PRINT "                                                           "
  COLOR 15, 7, 7

RETURN

makefrq:
  f = znum * 1000
  a1 = f - 21400
  a2 = INT(a1 / 400)
  a3 = a1 MOD 400
  a4 = a3 / 6.25
  a5 = a2 * 128
  a6 = a4 + a5
  frqh = FIX(a6 / 256)
  frql = FIX(a6 MOD 256)
RETURN


txmakefrq:
  f = znum * 1000
  a1 = f
  a2 = INT(a1 / 400)
  a3 = a1 MOD 400
  a4 = a3 / 6.25
  a5 = a2 * 128
  a6 = a4 + a5
  frqh = FIX(a6 / 256)
  frql = FIX(a6 MOD 256)
RETURN

dspstat:
  IF dtyp = 1 THEN GOSUB march00
  IF dtyp = 2 THEN GOSUB marchP1
  IF dtyp = 3 THEN GOSUB marchP2
  IF dtyp = 4 THEN GOSUB marchP3
  IF dtyp = 5 THEN GOSUB marchp4
  IF dtyp = 6 THEN GOSUB marchP5
  IF dtyp = 7 THEN GOSUB marchP6

  LOCATE ctry, ctr + 46
  COLOR dun, 7, 7
  IF frqh = 255 THEN
    PRINT " NONE"
  ELSE

  frql = frql - 224
  a = 0
  IF frql < 0 THEN
    frql = frql + 256
    a = 1
  END IF
  frqh = frqh - a - 26

    PRINT USING " ###.###"; pll2frq!(frqh, frql)
    LOCATE ctry, ctr + 18
    IF (stat AND 1) = 1 THEN PRINT "Duplex "
    IF (stat AND 1) = 0 THEN PRINT "Simplex"
    LOCATE ctry, ctr + 28
    IF (stat AND 6) = 0 THEN PRINT "Full PWR"
    IF (stat AND 6) = 2 THEN PRINT "1W ONLY"
    IF (stat AND 6) > 2 THEN PRINT "NO TX"
    LOCATE ctry, ctr + 4
    IF (chan AND 240) = 160 THEN PRINT USING "L#"; chan AND 15
    IF (chan AND 240) = 176 THEN PRINT USING "F#"; chan AND 15
    IF (chan AND 240) = 192 THEN PRINT USING "P#"; chan AND 15
  END IF
  COLOR 15, 7, 7

RETURN

mar21:                                ' channel 00
  ctry = 6
  dtyp = 1
  GOSUB gtmfreq
  IF znum <> 0 THEN
    GOSUB txmakefrq

  ELSE
    frqh = 255
    frql = 255
  END IF

  image(37, 14) = frqh                ' MSB
  image(37, 15) = frql                ' LSB

  image(38, 0) = 0                    ' channel 0

  GOSUB gtmsim
  image(38, 1) = num - 1

  GOSUB gtmpwr
  image(38, 1) = image(38, 1) OR ((num - 1) * 2)

RETURN

mar22:
  ctry = 7
  dtyp = 2
  GOSUB gtmfreq

  IF znum <> 0 THEN
    GOSUB txmakefrq

  ELSE
    frqh = 255
    frql = 255
  END IF

  image(51, 14) = frqh
  image(51, 15) = frql

  GOSUB gtmsim
  image(52, 1) = num - 1

  GOSUB gtmpwr
  image(52, 1) = image(52, 1) OR ((num - 1) * 2)

  GOSUB gtmchn
  IF num = 1 THEN image(52, 0) = 161
  IF num = 2 THEN image(52, 0) = 193

RETURN

mar23:
  ctry = 8
  dtyp = 3

  GOSUB gtmfreq
  IF znum <> 0 THEN
    GOSUB txmakefrq

  ELSE
    frqh = 255
    frql = 255
  END IF

  image(52, 2) = frqh
  image(52, 3) = frql

  GOSUB gtmsim
  image(52, 5) = num - 1

  GOSUB gtmpwr
  image(52, 5) = image(52, 5) OR ((num - 1) * 2)

  GOSUB gtmchn
  IF num = 1 THEN image(52, 4) = 162
  IF num = 2 THEN image(52, 4) = 194

RETURN


mar24:
  ctry = 9
  dtyp = 4
  GOSUB gtmfreq
  IF znum <> 0 THEN
    GOSUB txmakefrq

  ELSE
    frqh = 255
    frql = 255
  END IF

  image(52, 6) = frqh
  image(52, 7) = frql

  GOSUB gtmsim
  image(52, 9) = num - 1

  GOSUB gtmpwr
  image(52, 9) = image(52, 9) OR ((num - 1) * 2)

  GOSUB gtmchn
  IF num = 1 THEN image(52, 8) = 163
  IF num = 2 THEN image(52, 8) = 195

RETURN

mar25:
  ctry = 10
  dtyp = 5
  GOSUB gtmfreq
  IF znum <> 0 THEN
    GOSUB txmakefrq

  ELSE
    frqh = 255
    frql = 255
  END IF

  image(52, 10) = frqh
  image(52, 11) = frql

  GOSUB gtmsim
  image(52, 13) = num - 1

  GOSUB gtmpwr
  image(52, 13) = image(52, 13) OR ((num - 1) * 2)

  GOSUB gtmchn
  IF num = 1 THEN image(52, 12) = 177
  IF num = 2 THEN image(52, 12) = 196

RETURN

mar26:
  ctry = 11
  dtyp = 6
  GOSUB gtmfreq
  IF znum <> 0 THEN
    GOSUB txmakefrq

  ELSE
    frqh = 255
    frql = 255
  END IF

  image(52, 14) = frqh
  image(52, 15) = frql

  GOSUB gtmsim
  image(53, 1) = num - 1

  GOSUB gtmpwr
  image(53, 1) = image(53, 1) OR ((num - 1) * 2)

  GOSUB gtmchn
  IF num = 1 THEN image(53, 0) = 178
  IF num = 2 THEN image(53, 0) = 197

RETURN

mar27:
  ctry = 12
  dtyp = 7
  GOSUB gtmfreq
  IF znum <> 0 THEN
    GOSUB txmakefrq

  ELSE
    frqh = 255
    frql = 255
  END IF

  image(53, 2) = frqh
  image(53, 3) = frql

  GOSUB gtmsim
  image(53, 5) = num - 1

  GOSUB gtmpwr
  image(53, 5) = image(53, 5) OR ((num - 1) * 2)

  GOSUB gtmchn
  IF num = 1 THEN image(53, 4) = 179
  IF num = 2 THEN image(53, 4) = 198

RETURN

abat1:
LOCATE ctra, ctr
  PRINT "   Battery save time  (range:250-2550 [msec.]) ==>       "
RETURN

batsav1a:
  GOSUB shwbat

batsav1:
arp7:
  GOSUB abat1
  y = ctra
  x = ctr + 50
  T = 4
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO arp7
  tmin = 250                  '******************* was 10
  tmax = 2550
  sp = 10
  GOSUB chktim                ' check and round the time
  IF errfg = 0 THEN
    PRINT CHR$(7)             ' beep
    GOTO arp7
  END IF
  LOCATE ctra, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7

RETURN

abat2:
  LOCATE ctra + 1, ctr
  PRINT "   Watch for carrier  (range:250-2550 [msec.]) ==>       "
RETURN


batsav2a:
  GOSUB shwbat

batsav2:
arp8:
  GOSUB abat2
  y = ctra + 1
  x = ctr + 50
  T = 4
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO arp8
  tmin = 250                  'was 10
  tmax = 2550
  sp = 10
  GOSUB chktim                ' check and round the time
  IF errfg = 0 THEN
    PRINT CHR$(7)             ' beep
    GOTO arp8
  END IF
  LOCATE ctra + 1, ctr + 50
  COLOR dun, 7, 7
  PRINT USING " ####"; num
  COLOR 15, 7, 7

RETURN


abat3:
  LOCATE ctra + 2, ctr
  PRINT "   Battery save timeout  (range:1-255 [sec.]) ==>        "
RETURN

batsav3a:
  GOSUB shwbat
batsav3:

arp9:
  GOSUB abat3
  y = ctra + 2
  x = ctr + 50
  T = 3
  GOSUB getnum                'get the number
  IF jge = 1 THEN GOTO arp9
  tmin = 0
  tmax = 255
  sp = 1
  GOSUB chktim                ' check and round the time
  IF errfg = 0 THEN
    PRINT CHR$(7)             ' beep
    GOTO arp9
  END IF
  LOCATE ctra + 2, ctr + 50
  COLOR dun, 7, 7
  PRINT USING "  ###"; num
  COLOR 15, 7, 7
RETURN

clrbot:
  COLOR 15, 1, 1
  y = 20
  FOR x = 1 TO 6
    LOCATE y, 5
    y = y + 1
    PRINT "                                                                          ";
  NEXT x
  COLOR 15, 7, 7
RETURN

theend:
  COLOR 15, 0, 0
  CLS
  END


clrky:
  WHILE i$ <> ""
    i$ = INKEY$
  WEND
RETURN

getnum:
  num$ = ""
  num = 99999!
  jge = 0
getnm1:
  GOSUB clrky
  WHILE i$ = ""                     'wait for a key
    i$ = INKEY$
  WEND
  IF i$ = CHR$(27) THEN             ' esc, clear answer
     jge = 1
     RETURN
  END IF
  IF i$ = CHR$(13) THEN             ' finished
     RETURN
  END IF
  IF T = 0 THEN                     ' no more allowed
    GOTO getnm1
  END IF
  IF (48 <= ASC(i$) AND ASC(i$) <= 57) OR ASC(i$) = 46 THEN
    LOCATE y, x
    PRINT i$
    x = x + 1
    T = T - 1
    num$ = num$ + i$
    GOTO getnm1
  ELSE
    GOTO getnm1
  END IF

RETURN

chktim:
  num = VAL(num$)
  errfg = 1
  IF num < tmin OR num > tmax THEN
    errfg = 0
    RETURN
  END IF
  num = FIX(FIX((num - tmin) / sp + .5)) * sp + tmin
RETURN

chkfrq1:
  znum = VAL(num$)
  errfg = 1
  IF znum < zfmin OR znum > zfmax THEN
    errfg = 0
    RETURN
  END IF
  znum = FIX(FIX((znum - zfmin) / zfsp + .5)) * zfsp + zfmin
RETURN

chkfrq:
  errfg = 1
  znum = VAL(num$)
  IF znum < zfmin OR znum > zfmax THEN
    errfg = 0
    RETURN
  END IF
  a = (znum - zfmin) / zfsp
  b = FIX(a)
  IF a <> b THEN
    errfg = 0
  END IF
RETURN


' get any key
anykey:
  WHILE INKEY$ = ""
  WEND
  WHILE INKEY$ <> ""
  WEND
RETURN

chkmode:
  mar = 0
  pmr = 0
  arp = 0

  IF (image(18, 4) AND 128) = 128 THEN mar = 1
  IF (image(18, 4) AND 64) = 64 THEN pmr = 1
  IF (image(18, 4) AND 32) = 32 THEN arp = 1
RETURN

a5dig:
  LOCATE 7, ctr
  PRINT "   5 digit ARP ID#                            ==>        "
RETURN

absy:
  LOCATE 8, ctr
  PRINT "   Busy tone timeout      (range:1-10 [sec.]) ==>        "
RETURN

afree:
  LOCATE 9, ctr
  PRINT "   Free channel wait      (range:1-10 [sec.]) ==>        "
RETURN

aopen:
  LOCATE 10, ctr
  PRINT "   Opening signal wait    (range:1-10 [sec.]) ==>        "
RETURN

apause:
  LOCATE 11, ctr
  PRINT "   Pause after open       (range:1-10 [sec.]) ==>        "
RETURN

asid:
  LOCATE 12, ctr
  PRINT "   SID option    (1:SID only  2:SID+DIAL MEM) ==>        "
RETURN

lctcss:
  LOCATE 6, ctr
  PRINT "   CTCSS option                 (1:NO  2:YES) ==>        "
RETURN

ldulm:
  LOCATE 13, ctr
  PRINT "   Watch main channel(range:50-12750 [msec.]) ==>        "
RETURN

rtslstn:
  LOCATE 15, ctr
  PRINT "   RTS listen timeout    (range:1-255 [sec.]) ==>        "
RETURN

rtsact:
  LOCATE 16, ctr
  PRINT "   RTS Active timeout    (range:1-255 [sec.]) ==>        "
RETURN

ctcdly:
  LOCATE 17, ctr
  PRINT "   CTCSS delay        (range:10-2550 [msec.]) ==>        "
RETURN

ldulp:
  LOCATE 14, ctr
  PRINT "   Watch PRI channel  (range:10-2550 [msec.]) ==>        "
RETURN

lid:
  LOCATE 4, ctr
  PRINT "   Enter 4/5/6 digit LAND MOBILE ID#          ==>        "
RETURN

lrts:
  LOCATE 8, ctr
  PRINT "   Return to Standby            (1:NO  2:YES) ==>        "
RETURN

actlck:
  LOCATE 7, ctr
  PRINT "   Open state Locked            (1:NO  2:YES) ==>        "
RETURN

lscndl:
  LOCATE 12, ctr
  PRINT "   Scan Delay time    (range:10-2550 [msec.]) ==>        "
RETURN

lscndr:
  LOCATE 9, ctr
  PRINT "   Scan direction              (1:UP  2:DOWN) ==>        "
RETURN

lscntm:
  LOCATE 11, ctr
  PRINT "   Scan Resume time   (range:10-2550 [msec.]) ==>        "
RETURN

lscntp:
  LOCATE 10, ctr
  PRINT "   Scan type   (1:Type A  2:Type B  3:Type C) ==>        "
RETURN

ltxt:
  LOCATE 5, ctr
  PRINT "   Tx timeout   (1:1min 2:2min 3:3min 4:Cont) ==>        "
RETURN

mainmnu:
  ctr = 20
  COLOR 15, 8, 8
  LOCATE 11, ctr
  PRINT "               Main menu              "
  PRINT
  COLOR 15, 7, 7
  LOCATE 12, ctr
  PRINT "                                      "
  LOCATE 13, ctr
  PRINT " F1--Configuration Menu               "
  LOCATE 14, ctr
  PRINT " F2--Recall configuration from DISK   "
  LOCATE 15, ctr
  PRINT " F3--Store configuration to DISK      "
  LOCATE 16, ctr
  PRINT " F4--Recall configuration from EEPROM "
  LOCATE 17, ctr
  PRINT " F5--Store configuration to EEPROM    "
  LOCATE 18, ctr
  PRINT " F10-Quit                             "
  LOCATE 19, ctr
  PRINT "                                      "
  COLOR 15, 1, 1
RETURN

march00:
  LOCATE 6, ctr
  PRINT " CH 00                                     ==>            "
RETURN

march00a:
  LOCATE 20, ctr
  PRINT " Channel type        (1:SIMPLEX 2:DUPLEX)  ==>            "
RETURN

march00b:
  LOCATE 21, ctr
  PRINT " TX level  (1:FULL PWR 2:1W only 3:NO TX)  ==>            "
RETURN

marchP1:
  LOCATE 7, ctr
  PRINT " CH P1                                     ==>            "
RETURN

marchP2:
  LOCATE 8, ctr
  PRINT " CH P2                                     ==>            "
RETURN

marchP3:
  LOCATE 9, ctr
  PRINT " CH P3                                     ==>            "
RETURN

marchp4:
  LOCATE 10, ctr
  PRINT " CH P4                                     ==>            "
RETURN

marchP5:
  LOCATE 11, ctr
  PRINT " CH P5                                     ==>            "
RETURN

marchP6:
  LOCATE 12, ctr
  PRINT " CH P6                                     ==>            "
RETURN

marchPxc:
  LOCATE 22, ctr
  IF dtyp < 5 THEN
    PRINT " Channel Number               (1:Lx 2:Px)  ==>            "
  ELSE
    PRINT " Channel Number               (1:Fx 2:Px)  ==>            "
  END IF
RETURN

mdulm:
  LOCATE 11, ctr
  PRINT "   Watch main channel(range:50-12750 [msec.]) ==>        "
RETURN

mdulp:
  LOCATE 12, ctr
  PRINT "   Watch PRI channel  (range:10-2550 [msec.]) ==>        "
RETURN

menu1:
  ctr = 27
  COLOR 15, 8, 8
  LOCATE 6, ctr
  PRINT "    Select mode to program     "
  COLOR 15, 7, 7
  LOCATE 7, ctr
  PRINT "                               "
  LOCATE 8, ctr
  PRINT "  F1--ARP Timing               "
  LOCATE 9, ctr
  PRINT "  F2--Land Mobile Timing       "
  LOCATE 10, ctr
  PRINT "  F3--Land Mobile Tone Encoder "
  LOCATE 11, ctr
  PRINT "  F4--Land Mobile Tone DEcoder "
  LOCATE 12, ctr
  PRINT "  F5--Land Mobile Frequencies  "
  LOCATE 13, ctr
  PRINT "  F6--MARINE Timing/channels   "
  LOCATE 14, ctr
  PRINT "  F10-Return to main           "
  LOCATE 15, ctr
  PRINT "                               "
  COLOR 15, 1, 1                'blue background
RETURN

mscndl:
  LOCATE 10, ctr
  PRINT "   Scan Delay time    (range:10-2550 [msec.]) ==>        "
RETURN

mscndr:
  LOCATE 7, ctr
  PRINT "   Scan direction              (1:UP  2:DOWN) ==>        "
RETURN

mscnrt:
  LOCATE 9, ctr
  PRINT "   Scan Resume time   (range:10-2550 [msec.]) ==>        "
RETURN

mscntp:
  LOCATE 8, ctr
  PRINT "   Scan type   (1:Type A  2:Type B  3:Type C) ==>        "
RETURN

mtxt:
  LOCATE 6, ctr
  PRINT "   Tx timeout   (1:1min 2:2min 3:3min 4:Cont) ==>        "
RETURN

scana:
'  COLOR 15, 2, 2
'  LOCATE 20, 5
'  PRINT "                   Scan type A                                           "
'  COLOR 15, 7, 7
'  LOCATE 21, 5
'  PRINT " 01 --> 02 --> 03 --> 04 [recieving][not rx] --> 05 --> 06 ...           "
'  LOCATE 22, 5
'  PRINT "                                                   "
'  LOCATE 23, 5
'  PRINT " Scan resume time                   Scan delay time                      "
'  LOCATE 24, 5
'  PRINT "                                                                         ";
RETURN

scanb:
'  COLOR 15, 2, 2
'  LOCATE 20, 5
'  PRINT "                   Scan type B                                           "
'  COLOR 15, 7, 7
'  LOCATE 21, 5
'  PRINT " 01 --> PRI --> 02 --> PRI [recieving][not rx] --> 03 --> PRI --> 04 ... "
'  LOCATE 22, 5
'  PRINT "                                                   "
'  LOCATE 23, 5
'  PRINT " Scan resume time                    Scan delay time                     "
'  LOCATE 24, 5
'  PRINT "                                                                         ";
RETURN

scanc:
'  COLOR 15, 2, 2
'  LOCATE 20, 5
'  PRINT "                    Scan type C                                          "
'  COLOR 15, 7, 7
'  LOCATE 21, 5
'  PRINT " 01 --> 02 --> PRI --> 03 --> 04 [recieving][not rx] --> PRI --> 05 ...  "
'  LOCATE 22, 5
'  PRINT "                                                   "
'  LOCATE 23, 5
'  PRINT " Scan resume time                           Scan delay time              "
'  LOCATE 24, 5
'  PRINT "                                                                         ";
RETURN

shwbat:
'  COLOR 15, 2, 2
'  LOCATE 20, 5
'  PRINT "                       Battery Save mode                                 "
'  COLOR 15, 7, 7
'  LOCATE 21, 5
'  PRINT "         Ŀ                "
'  LOCATE 22, 5
'  PRINT "   Rx ON             Recieving                "
'  LOCATE 23, 5
'  PRINT "         Watch for carrier   Battery save time                           "
'  LOCATE 24, 5
'  PRINT "                                                                         ";
RETURN

shwdul:
'  COLOR 15, 2, 2
'  LOCATE 20, 5
'  PRINT "                          Dual Watch                                     "
'  COLOR 15, 7, 7
'  LOCATE 21, 5
'  PRINT "        01 --> PRI --> 03 --> PRI --> 04 --> PRI --> ...                 "
'  LOCATE 22, 5
'  PRINT "                                                          "
'  LOCATE 23, 5
'  PRINT "        Main channel Watch time    PRI watch time                        "
'  LOCATE 24, 5
'  PRINT "                                                                         ";
RETURN

progmode:
  CLS
  title
  ctr = 20
  LOCATE 6, ctr
  COLOR 15, 8, 8
  PRINT "              MODE options               "
  image(18, 4) = 0
prgm1:
  COLOR 15, 7, 7
  LOCATE 7, ctr
  PRINT " ARP mode enabled    (0=no 1=yes) ==>    "
  y = 7
  x = ctr + 39
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO prgm1
  num = VAL(num$)
  IF num > 1 THEN GOTO prgm1
  IF num = 1 THEN
    image(18, 4) = image(18, 4) OR 32
  ELSE
    image(18, 4) = image(18, 4) AND 223
  END IF

  title

prgm2:
  COLOR 15, 7, 7
  LOCATE 8, ctr
  PRINT " PMR mode enabled    (0=no 1=yes) ==>    "
  y = 8
  x = ctr + 39
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO prgm2
  num = VAL(num$)
  IF num > 1 THEN GOTO prgm2
  IF num = 1 THEN
    image(18, 4) = image(18, 4) OR 64
  ELSE
    image(18, 4) = image(18, 4) AND 161
  END IF

  title

prgm3:
  COLOR 15, 7, 7
  LOCATE 9, ctr
  PRINT " MAR mode enabled    (0=no 1=yes) ==>    "
  y = 9
  x = ctr + 39
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO prgm3
  num = VAL(num$)
  IF num > 1 THEN GOTO prgm3
  IF num = 1 THEN
    image(18, 4) = image(18, 4) OR 128
  ELSE
    image(18, 4) = image(18, 4) AND 127
  END IF

  title

prgm4:
  COLOR 15, 7, 7
  LOCATE 10, ctr
  PRINT " Default mode (1:ARP 2:PMR 3:MAR) ==>    "
  y = 10
  x = ctr + 39
  T = 1
  GOSUB getnum
  IF jge = 1 THEN GOTO prgm4
  num = VAL(num$)
  IF num < 1 OR num > 3 THEN
    PRINT CHR$(7)
    GOTO prgm4
  END IF
  image(18, 4) = image(18, 4) AND 224
  IF num = 1 THEN image(18, 4) = image(18, 4) OR 1
  IF num = 2 THEN image(18, 4) = image(18, 4) OR 2
  IF num = 3 THEN image(18, 4) = image(18, 4) OR 4

COLOR 15, 1, 1

RETURN

openit:
  dsp = 1
  CLS
  title
  LOCATE 5, 18
  PRINT "Connect radio to computer via special cable."
  LOCATE 6, 29
  PRINT "Turn on the radio now."
  LOCATE 7, 19
'  PRINT "If the display shows 'EEPr' then press '5'"
'  LOCATE 8, 27
'  PRINT "otherwise enter:  * D * 9"
'  LOCATE 9, 23
'  PRINT "The Radio display should say ProG"
'  LOCATE 10, 21
  PRINT "Press any key when radio is connected"
  GOSUB anykey

'  05/29/92 OPEN THE RADIO FOR EEPROM PROGRAMMING
  byt1 = 192
  byt2 = 255 - byt1
  sndbyt

'  LOCATE 8, 29
'  PRINT "Turn ON the radio now"

'  a = 5                           ' watch for data line
'  b = 0
'  WHILE b = 0
'    a = a XOR 2                   ' wiggle the clock line
'    OUT 888, a
'    IF (a AND 2) = 0 THEN         ' check when clock low
'      b = INP(889) AND 128          ' watch for data line to go high
'    END IF
'  WEND
'  OUT 888, 6                        ' clock line back high

'  CLS
'  title
'  LOCATE 4, 18
'  PRINT "The AML unit has beem successfully unlocked"

  FOR x = 1 TO 1000
  NEXT x

RETURN

' this will unlock the radio and dump image to the eeprom
recalleep:
  GOSUB openit
  LOCATE 4, 26
  PRINT "                                                       "
  PRINT "                                                       "
  PRINT "                                                        "
  LOCATE 5, 26
  PRINT "Recalling data from AML unit"
  GOSUB recall
  GOSUB chkmode
RETURN


recall:
  O = 4                       ' out byte
  OUT 888, O
  O = O OR 1
  OUT 888, O
  O = O OR 2
  OUT 888, O                  ' data high/clock high for INITIAL condition

  page(0) = 0                 ' MSB
  page(1) = 0                 ' LSB

  O = O AND 254
  OUT 888, O                      ' bring data low for START condition
  O = O AND 253
  OUT 888, O                      ' clock low

  eebyt = 160                      ' setup the start byte
  locat = page(0) * 2              ' msb of page
  eebyt = (eebyt OR locat) AND 255 ' Add page to start byte
  GOSUB sndeep                     ' send a byte to the eeprom & get an ACK
  eebyt = page(1)                  ' lsb of page
  GOSUB sndeep                     ' send the page

  O = O OR 1
  OUT 888, O                      ' data high
  O = O OR 2
  OUT 888, O                      ' clock high
  O = O AND 254
  OUT 888, O                      ' bring data low for START condition
  O = O OR 1
  OUT 888, 4                      ' bring clock line low

  eebyt = 161                     ' setup the read byte
  locat = page(0) * 2              ' msb of page
  eebyt = (eebyt OR locat) AND 255 ' Add page to start byte
  GOSUB sndeep                     ' send a byte to the eeprom & get an ACK

  FOR z = 0 TO 127
    FOR y = 0 TO 15
      GOSUB geteep                 ' read a byte
      image(z, y) = eebyt
      LOCATE 10, 32
      PRINT USING "Reading ### "; z
      IF (z = 127) AND (y = 15) THEN
	'DO NOTHING
      ELSE
	O = O AND 254
	OUT 888, O                        ' send data line as an ack
	O = O OR 2
	OUT 888, O
	O = O AND 253
	OUT 888, O                        ' strobe clock
      END IF
    NEXT y
  NEXT z

  O = O AND 254
  OUT 888, O                      ' data low
  O = O OR 2
  OUT 888, O                      ' bring clock high
  O = O OR 1
  OUT 888, O                      ' bring data high for STOP condition

RETURN

geteep:
  O = O OR 1
  OUT 888, O                      ' data line high & clock low
  tmp = 0

  FOR x = 1 TO 8
    tmp = (tmp * 2) AND 255
    O = O OR 2
    OUT 888, O                      ' clock high & data high
    a = INP(889) AND 128            ' read data line
    O = O AND 253
    OUT 888, O                      ' clock low & data high

    IF a = 128 THEN
      eectl = 0                     ' invert the data
    ELSE
      eectl = 1
    END IF
    tmp = tmp OR eectl
  NEXT x
  eebyt = tmp
'  PRINT HEX$(tmp); ":";

RETURN


' this will unlock the radio and dump image to the eeprom
program:
  GOSUB progmode
  GOSUB openit
  LOCATE 4, 30
  PRINT "                                                              "
  PRINT "                                                              "
  PRINT "                                                              "
  LOCATE 5, 30
  PRINT "Programming AML unit"
  GOSUB unlokd
RETURN

unlokd:
  O = 4
  OUT 888, O                  ' data/clock low
  O = O OR 1
  OUT 888, O                  ' data high
  O = O OR 2
  OUT 888, O                  ' data high/clock high for INITIAL condition

  page(0) = 0                 ' MSB
  page(1) = 0                 ' LSB

  image(20, 14) = 17           ' eeprom has been programmed
  image(20, 15) = 79

  FOR z = 0 TO 127
    GOSUB sndstr
    page(1) = page(1) + 16    ' move to next page
    IF page(1) > 255 THEN
      page(1) = 0
      page(0) = page(0) + 1
    END IF
    FOR w = 1 TO 200          ' delay for write
    NEXT w
  NEXT z

RETURN


sndstr:
  O = 4                           '????
  OUT 888, O
  O = O OR 1
  OUT 888, O                      ' data line high
  O = O OR 2
  OUT 888, O                      ' clock and data high
  O = O AND 254
  OUT 888, O                      ' bring data low for START condition
  O = O AND 253
  OUT 888, O                      ' bring clock line low

  eebyt = 160                      ' setup the start byte
  locat = page(0) * 2              ' msb of page
  eebyt = (eebyt OR locat) AND 255 ' Add page to start byte
  LOCATE 11, 16
'  PRINT USING "eebyt = ###"; eebyt
  GOSUB sndeep                     ' send a byte to the eeprom & get an ACK
  eebyt = page(1)                  ' lsb of page
  GOSUB sndeep                     ' send the page
  eebyt = 0
  FOR y = 0 TO 15
    LOCATE 10, 30
    PRINT USING "Programming ### "; z
    eebyt = image(z, y)
    GOSUB sndeep
  NEXT y

  O = O AND 252
  OUT 888, O                      ' clock and data low
  O = O OR 2
  OUT 888, O                      ' bring clock high
  O = O OR 1
  OUT 888, O                      ' bring data high for STOP condition

RETURN


sndeep:
  tmp = eebyt
  FOR x = 1 TO 8                  ' send 8 bits
    IF (tmp AND 128) = 128 THEN
      O = O OR 1                   ' send a 1
    ELSE
      O = O AND 254                ' send a 0
    END IF
    OUT 888, O                    ' output data
    GOSUB clock                   ' strobe the clock
    tmp = (tmp * 2) AND 255       ' limit to 00-255
  NEXT x
  GOSUB getack                    ' get an ack
RETURN


getack:
  O = O AND 254                   ' OR 1
  OUT 888, O                      ' data line high
  O = O OR 2
  OUT 888, O                      ' clock high
  WHILE a = 0
    a = INP(889) AND 128          ' watch for ack
  WEND
  O = O AND 253
  OUT 888, O                      ' clock low
RETURN

clock:
  O = O OR 2              ' clock high
  OUT 888, O              ' output eeprom control byte
  O = O AND 253
  OUT 888, O              ' clock low
RETURN

CCIRTON:
DATA &H31,&H87,&H7B,&H6F,&H65,&H5B,&H51,&H48,&H40,&H38,&H1D,&HB1,&H24
DATA &HA2,&H2A,&H32,&H91,&H96

CTCSSDT:
DATA 192,255,252,67.0,124,71.9,248,74.4,60,77.0,244,79.7,120,82.5,240,85.4
DATA 56,88.5,236,91.5,116,94.8,232,97.4,52,100.0,112,103.5,48,107.2
DATA 108,110.9,44,114.8,104,118.8,40,123.0
DATA 100,127.3,36,131.8,96,136.5,32,141.3,92,146.2,28,151.4,88,156.7
DATA 24,162.2,84,167.9,20,173.8,80,179.9,16,186.2,76,192.8,12,203.5
DATA 72,210.7,8,218.1,68,225.7,4,233.6,64,241.8,0,250.3


CCIRTAB:
DATA 73,77,88,94,100,106,113,121,129,137,143,146,155,165,176,188,255
DATA 76,81,92,98,104,111,118,126,134,142,147,152,162,172,183,196,255
DATA &HB,&HD,1,2,3,4,5,6,7,8,&H12,9,0,&HE,&HC,&HA,&HF

' ARP DATA TABLE EACH ENTRY CONSISTS OF 2 BYTES OF RX PLL DATA
ARPFRQ:
' channel 00-06
DATA &H9F,&H08,&H9F,&H24,&H9F,&H80,&H9F,&H10,&H9F,&H28,&H9F,&H8C,&H9F,&H38
' Channel 07-13
DATA &H9F,&H1C,&HA0,&H00,&HF8,&H63,&H9F,&H84,&HA0,&H0C,&HA0,&H24,&HA0,&H34
' Channel 14-20
DATA &HA0,&H80,&HA0,&H2C,&HA0,&H08,&H9F,&HAC,&H9F,&HA4,&H9F,&HA0,&H9F,&H14
' Channel 21-27
DATA &HA0,&H84,&HA0,&H10,&H9F,&HB4,&HA0,&H18,&H9E,&H8C,&H9E,&H80,&HF8,&H1E
' Channel 28-34
DATA &HFF,&HFF,&HF8,&H1A,&H9F,&H88,&HA0,&H30,&H9E,&H24,&H9E,&HB4,&H9F,&H94
' Channel 35-40
DATA &H9F,&H30,&H9F,&H2C,&H9F,&H0C,&H9F,&H90,&H9F,&H04,&H9F,&H3C
' Channel 41-47
DATA &HA0,&H04,&HA0,&H88,&H9E,&H28,&H9E,&H38,&HF8,&H32,&HFF,&HFF,&HFF,&HFF
' Channel 48-54
DATA &HFF,&HFF,&HF8,&H2C,&H9F,&H20,&HA0,&H1C,&H9E,&H20,&H9E,&H14,&HF8,&H3C
' Channel 55-61
DATA &HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HF8,&H35,&H9F,&H18,&HA0,&H8C
' Channel 62-68
DATA &HA0,&H28,&HA0,&H38,&HA0,&H3C,&H9E,&H90,&H9E,&H1C,&H9E,&H94,&HF8,&H46
' Channel 69-75
DATA &HF8,&H43,&H9F,&H34,&H9F,&HB0,&HA0,&H14,&H9F,&HBC,&H9E,&H98,&H9E,&HA0
' Channel 76-82
DATA &HF8,&H50,&HFF,&HFF,&HFF,&HFF,&HF8,&H4B,&H9E,&H84,&H9E,&H18,&H9E,&H2C
' Channel 83-89
DATA &H9E,&H10,&H9E,&H30,&H9E,&HB0,&H9E,&H88,&H9E,&HA8,&H9E,&H3C,&H9E,&H34
' Channel 90-96
DATA &H9E,&HA4,&H9E,&HAC,&H9F,&H00,&H9F,&H9C,&H9F,&HA8,&HA0,&H20,&H9E,&HBC
' Channel 97-99
DATA &H9E,&HB8,&H9E,&H9C,&H9F,&HB8,&HF8,&H0A

'     06/19/92
' EACH ENTRY CONSISTS OF:
' 2 BYTES OF PLL DATA
' CHANNEL # FOR DISPLAY IN BCD
' STATUS BYTE:
'  BIT 0 - 0=SIMPLEX/1=DUPLEX
'  BIT 1 - 0=HI PWR/1=LO PWR
'  BIT 2 - 0=NORM/1=TX INHIBIT
'  BIT 3 - Q4 CLOCK SHIFT CONTROL
'  BIT 4 -
'  BIT 5 -
'  BIT 6 -
'  BIT 7 -
marfrq:
' Channel 00-03
DATA &HFF,&HFF,&HFF,&HFF,&HC3,&H08,&H01,&H01,&HC3,&H10,&H02,&H01,&HC3,&H18
' Channel 03-06
DATA &H03,&H01,&HC3,&H20,&H04,&H01,&HC3,&H28,&H05,&H01,&HC3,&H30,&H06,&H00
' Channel 07-10
DATA &HC3,&H38,&H07,&H01,&HC3,&H80,&H08,&H00,&HC3,&H88,&H09,&H00,&HC3,&H90
' Channel 10-13
DATA &H10,&H00,&HC3,&H98,&H11,&H00,&HC3,&HA0,&H12,&H00,&HC3,&HA8,&H13,&H00
' Channel 14-17
DATA &HC3,&HB0,&H14,&H00,&HC3,&HB8,&H15,&H08,&HC4,&H00,&H16,&H00,&HC4,&H08
' Channel 17-20
DATA &H17,&H00,&HC4,&H10,&H18,&H01,&HC4,&H18,&H19,&H01,&HC4,&H20,&H20,&H09
' Channel 21-24
DATA &HC4,&H28,&H21,&H01,&HC4,&H30,&H22,&H01,&HC4,&H38,&H23,&H01,&HC4,&H80
' Channel 24-27
DATA &H24,&H01,&HC4,&H88,&H25,&H01,&HC4,&H90,&H26,&H01,&HC4,&H98,&H27,&H01
' Channel 28-62
DATA &HC4,&HA0,&H28,&H01,&HC3,&H04,&H60,&H01,&HC3,&H0C,&H61,&H01,&HC3,&H14
' Channel 62-65
DATA &H62,&H01,&HC3,&H1C,&H63,&H01,&HC3,&H24,&H64,&H01,&HC3,&H2C,&H65,&H01
' Channel 66-69
DATA &HC3,&H34,&H66,&H01,&HC3,&H3C,&H67,&H00,&HC3,&H84,&H68,&H00,&HC3,&H8C
'                                !!!!!!!!!!!!!!!!!!!!
' Channel 69-72                  v TX inhibit on ch70
DATA &H69,&H00,&HC3,&H94,&H70,&H04,&HC3,&H9C,&H71,&H00,&HC3,&HA4,&H72,&H00
' Channel 73-78
DATA &HC3,&HAC,&H73,&H00,&HC3,&HB4,&H74,&H00,&HC4,&H0C,&H77,&H00,&HC4,&H14
' Channel 78-81
DATA &H78,&H01,&HC4,&H1C,&H79,&H01,&HC4,&H24,&H80,&H01,&HC4,&H2C,&H81,&H01
' Channel 82-85
DATA &HC4,&H34,&H82,&H01,&HC4,&H3C,&H83,&H01,&HC4,&H84,&H84,&H01,&HC4,&H8C
' Channel 85-88
DATA &H85,&H01,&HC4,&H94,&H86,&H01,&HC4,&H9C,&H87,&H01,&HC4,&HA4,&H88,&H01

' Channel L1,2,3 F1,2,3 P1,2,3,4,5,6
DATA &HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF
DATA &HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF,&HFF

FUNCTION ctcrx (chan)

  loct = (chan * 6) + 860
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  ctcrx = image(imgx, imgy)

END FUNCTION

FUNCTION ctctx (chan)

  loct = (chan * 6) + 861
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  ctctx = image(imgx, imgy)

END FUNCTION

FUNCTION ctrxpmr (chan)

  loct = (chan * 6) + 860
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  a = image(imgx, imgy)
  FOR b = 0 TO 77 STEP 2
    IF ctcss(b) = a THEN
      ctrxpmr = ctcss(b + 1)
    END IF
  NEXT b

END FUNCTION

FUNCTION cttxpmr (chan)

  loct = (chan * 6) + 861
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  a = image(imgx, imgy)
  FOR b = 0 TO 77 STEP 2
    IF ctcss(b) = a THEN
      cttxpmr = ctcss(b + 1)
    END IF
  NEXT b

END FUNCTION

SUB initlz

PRINT "                           Initalizing arrays..."

' initalize image to 255
FOR y = 0 TO 127
  FOR x = 0 TO 15
    image(y, x) = 255
  NEXT x
NEXT y

' INITALIZE SOME OF THE OTHER VALUES
image(18, 4) = 0
RESTORE CCIRTAB
FOR x = 21 TO 23
  FOR y = 0 TO 15
  READ a
  image(x, y) = a
  NEXT y
NEXT x
READ a
image(24, 0) = a
READ a
image(24, 1) = a
READ a
image(24, 2) = a

' READ CCIR TONE ENCODER
RESTORE CCIRTON
FOR y = 3 TO 15
  READ a
  image(24, y) = a
NEXT y
FOR y = 0 TO 3
  READ a
  image(25, y) = a
NEXT y

' initalize land mobile with ccir/arp table
' initalize with ccir encode table
RESTORE CCIRTON
FOR y = 3 TO 15
  READ a
  image(95, y) = a
NEXT y
FOR y = 0 TO 4
  READ a
  image(96, y) = a
NEXT y


' READ CCIR TONE ENCODER
RESTORE CCIRTAB
FOR x = 92 TO 94
  FOR y = 0 TO 15
    READ a
    image(x, y) = a
  NEXT y
NEXT x
FOR y = 0 TO 2
  READ a
  image(95, y) = a
NEXT y


' read in the arp frequency list
RESTORE ARPFRQ
FOR y = 4 TO 15
  READ a
  image(25, y) = a
NEXT y
FOR x = 26 TO 36
  FOR y = 0 TO 15
    READ a
    image(x, y) = a
  NEXT y
NEXT x
FOR y = 0 TO 13
  READ a
  image(37, y) = a
NEXT y

RESTORE marfrq
READ a
image(37, 14) = a
READ a
image(37, 15) = a
FOR x = 38 TO 52
  FOR y = 0 TO 15
    READ a
    image(x, y) = a
  NEXT y
NEXT x
FOR y = 0 TO 7
  READ a
  image(53, y) = a
NEXT y

RESTORE CTCSSDT
FOR x = 0 TO 77
  READ a
  ctcss(x) = a
NEXT x

' last channels
image(91, 8) = 10
image(91, 9) = 1
image(91, 10) = 1

' ignore and timout times for land mobile
image(96, 6) = 2
image(96, 7) = 29


END SUB

FUNCTION pll2frq! (frqh, frql) STATIC

  a6 = frqh * 256 + frql
  a = a6 MOD 128                                '8/20/92  WAS 64
  b = a6 - a
  c = (a + (b / 2)) * 6.25
  d = c + 21400
  pll2frq = d / 1000

END FUNCTION

FUNCTION pmrfx! (x) STATIC
  a = x * 6
  a = a + 856
  pmrfx! = FIX(a / 16)
  c = a - (b * 16)
END FUNCTION

FUNCTION pmrfy! (x)
  a = x * 6
  a = a + 856
  b = FIX(a / 16)
  pmrfy! = a - (b * 16)
END FUNCTION

FUNCTION rxpmr (chan)
  loct = (chan * 6) + 856
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  pllh = image(imgx, imgy)
  loct = loct + 1
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  plll = image(imgx, imgy)
  rxpmr = pll2frq(pllh, plll)

END FUNCTION

FUNCTION setlctrx (chan, num)
  loct = (chan * 6) + 860
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  image(imgx, imgy) = ctcss(num * 2)

END FUNCTION

FUNCTION setlcttx (chan, num)

  loct = (chan * 6) + 861
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  image(imgx, imgy) = ctcss(num * 2)

END FUNCTION

FUNCTION setlrx (frqh, frql, chan)
  loct = (chan * 6) + 856
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  image(imgx, imgy) = frqh
  loct = loct + 1
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  image(imgx, imgy) = frql

END FUNCTION

FUNCTION setltx (frqh, frql, chan)

  loct = (chan * 6) + 858
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  image(imgx, imgy) = frqh
  loct = loct + 1
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  image(imgx, imgy) = frql

END FUNCTION

SUB sndbyt

  OUT 888, 4
'  OUT 888, 4
  OUT 888, 5
  FOR y = 1 TO mid
  NEXT y

  FOR x = 1 TO 8
    IF (byt1 AND 128) = 128 THEN
      OUT 888, 4
'      OUT 888, 4
      OUT 888, 5
      FOR y = 1 TO hi
      NEXT y
    ELSE
      OUT 888, 4
'      OUT 888, 4
      OUT 888, 5
      FOR y = 1 TO low
      NEXT y
    END IF
    byt1 = byt1 * 2
  NEXT x

  FOR x = 1 TO 8
    IF (byt2 AND 128) = 128 THEN
      OUT 888, 4
'      OUT 888, 4
      OUT 888, 5
      FOR y = 1 TO hi
      NEXT y
    ELSE
      OUT 888, 4
'      OUT 888, 4
      OUT 888, 5
      FOR y = 1 TO low
      NEXT y
    END IF
    byt2 = byt2 * 2
  NEXT x
  OUT 888, 4
'  OUT 888, 4
  OUT 888, 5

END SUB

SUB title

  COLOR 15, 2, 2
  LOCATE 1, 1
  PRINT "                    AML EEPROM programming  v1.2b Ham version by OH7FXK         "
  COLOR 15, 5, 5
  LOCATE 2, 1

  mar = 0
  pmr = 0
  arp = 0

  IF (image(18, 4) AND 128) = 128 THEN mar = 1
  IF (image(18, 4) AND 64) = 64 THEN pmr = 1
  IF (image(18, 4) AND 32) = 32 THEN arp = 1

  IF mar = 1 THEN
    M$ = "MAR on"
  ELSE
    M$ = "MAR off"
  END IF
  IF arp = 1 THEN
    a$ = "ARP on"
  ELSE
    a$ = "ARP off"
  END IF
  IF pmr = 1 THEN
    L$ = "PMR on"
  ELSE
    L$ = "PMR off"
  END IF
  IF (image(18, 4) AND 7) = 1 THEN d$ = "ARP"
  IF (image(18, 4) AND 7) = 2 THEN d$ = "PMR"
  IF (image(18, 4) AND 7) = 4 THEN d$ = "MAR"
  IF image(18, 4) <> 0 THEN
    PRINT USING "  DEFAULT: \  \mode          STATUS: -\       \-\       \-\       \             "; d$; a$; L$; M$
  END IF

  COLOR 15, 1, 1

END SUB

FUNCTION txpll2frq! (frqh, frql) STATIC

  a6 = frqh * 256 + frql
  a = a6 MOD 64
  b = a6 - a
  c = (a + (b / 2)) * 6.25
  d = c
  txpll2frq = d / 1000

END FUNCTION

FUNCTION txpmr (chan)
  loct = (chan * 6) + 858
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  pllh = image(imgx, imgy)
  loct = loct + 1
  imgx = FIX(loct / 16)
  imgy = loct - (imgx * 16)
  plll = image(imgx, imgy)
  txpmr = txpll2frq!(pllh, plll)

END FUNCTION

